#ifndef _LAPACK_H_
#define _LAPACK_H_

#include "blas.h"

extern "C"
{
  void cbdsqr_(char *uplo, int *n, int *ncvt, int *nru, int *ncc, float *d, float *e, cpx8 *vt, int *ldvt, cpx8 *u, int *ldu, cpx8 *c, int *ldc, float *rwork, int *info);
  void cgbbrd_(char *vect, int *m, int *n, int *ncc, int *kl, int *ku, cpx8 *ab, int *ldab, float *d, float *e, cpx8 *q, int *ldq, cpx8 *pt, int *ldpt, cpx8 *c, int *ldc, cpx8 *work, float *rwork, int *info);
  void cgbcon_(char *norm, int *n, int *kl, int *ku, cpx8 *ab, int *ldab, int *ipiv, float *anorm, float *rcond, cpx8 *work, float *rwork, int *info);
  void cgbequ_(int *m, int *n, int *kl, int *ku, cpx8 *ab, int *ldab, float *r, float *c, float *rowcnd, float *colcnd, float *amax, int *info);
  void cgbrfs_(char *trans, int *n, int *kl, int *ku, int *nrhs, cpx8 *ab, int *ldab, cpx8 *afb, int *ldafb, int *ipiv, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void cgbsv_(int *n, int *kl, int *ku, int *nrhs, cpx8 *ab, int *ldab, int *ipiv, cpx8 *b, int *ldb, int *info);
  void cgbsvx_(char *fact, char *trans, int *n, int *kl, int *ku, int *nrhs, cpx8 *ab, int *ldab, cpx8 *afb, int *ldafb, int *ipiv, char *equed, float *r, float *c, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *rcond, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void cgbtf2_(int *m, int *n, int *kl, int *ku, cpx8 *ab, int *ldab, int *ipiv, int *info);
  void cgbtrf_(int *m, int *n, int *kl, int *ku, cpx8 *ab, int *ldab, int *ipiv, int *info);
  void cgbtrs_(char *trans, int *n, int *kl, int *ku, int *nrhs, cpx8 *ab, int *ldab, int *ipiv, cpx8 *b, int *ldb, int *info);
  void cgebak_(char *job, char *side, int *n, int *ilo, int *ihi, float *scale, int *m, cpx8 *v, int *ldv, int *info);
  void cgebal_(char *job, int *n, cpx8 *a, int *lda, int *ilo, int *ihi, float *scale, int *info);
  void cgebd2_(int *m, int *n, cpx8 *a, int *lda, float *d, float *e, cpx8 *tauq, cpx8 *taup, cpx8 *work, int *info);
  void cgebrd_(int *m, int *n, cpx8 *a, int *lda, float *d, float *e, cpx8 *tauq, cpx8 *taup, cpx8 *work, int *lwork, int *info);
  void cgecon_(char *norm, int *n, cpx8 *a, int *lda, float *anorm, float *rcond, cpx8 *work, float *rwork, int *info);
  void cgeequ_(int *m, int *n, cpx8 *a, int *lda, float *r, float *c, float *rowcnd, float *colcnd, float *amax, int *info);
  void cgees_(char *jobvs, char *sort, int *select, int *n, cpx8 *a, int *lda, int *sdim, cpx8 *w, cpx8 *vs, int *ldvs, cpx8 *work, int *lwork, float *rwork, int *bwork, int *info);
  void cgeesx_(char *jobvs, char *sort, int *select, char *sense, int *n, cpx8 *a, int *lda, int *sdim, cpx8 *w, cpx8 *vs, int *ldvs, float *rconde, float *rcondv, cpx8 *work, int *lwork, float *rwork, int *bwork, int *info);
  void cgeev_(char *jobvl, char *jobvr, int *n, cpx8 *a, int *lda, cpx8 *w, cpx8 *vl, int *ldvl, cpx8 *vr, int *ldvr, cpx8 *work, int *lwork, float *rwork, int *info);
  void cgeevx_(char *balanc, char *jobvl, char *jobvr, char *sense, int *n, cpx8 *a, int *lda, cpx8 *w, cpx8 *vl, int *ldvl, cpx8 *vr, int *ldvr, int *ilo, int *ihi, float *scale, float *abnrm, float *rconde, float *rcondv, cpx8 *work, int *lwork, float *rwork, int *info);
  void cgegs_(char *jobvsl, char *jobvsr, int *n, cpx8 *a, int *lda, cpx8 *b, int *ldb, cpx8 *alpha, cpx8 *beta, cpx8 *vsl, int *ldvsl, cpx8 *vsr, int *ldvsr, cpx8 *work, int *lwork, float *rwork, int *info);
  void cgegv_(char *jobvl, char *jobvr, int *n, cpx8 *a, int *lda, cpx8 *b, int *ldb, cpx8 *alpha, cpx8 *beta, cpx8 *vl, int *ldvl, cpx8 *vr, int *ldvr, cpx8 *work, int *lwork, float *rwork, int *info);
  void cgehd2_(int *n, int *ilo, int *ihi, cpx8 *a, int *lda, cpx8 *tau, cpx8 *work, int *info);
  void cgehrd_(int *n, int *ilo, int *ihi, cpx8 *a, int *lda, cpx8 *tau, cpx8 *work, int *lwork, int *info);
  void cgelq2_(int *m, int *n, cpx8 *a, int *lda, cpx8 *tau, cpx8 *work, int *info);
  void cgelqf_(int *m, int *n, cpx8 *a, int *lda, cpx8 *tau, cpx8 *work, int *lwork, int *info);
  void cgels_(char *trans, int *m, int *n, int *nrhs, cpx8 *a, int *lda, cpx8 *b, int *ldb, cpx8 *work, int *lwork, int *info);
  void cgelss_(int *m, int *n, int *nrhs, cpx8 *a, int *lda, cpx8 *b, int *ldb, float *s, float *rcond, int *rank, cpx8 *work, int *lwork, float *rwork, int *info);
  void cgelsx_(int *m, int *n, int *nrhs, cpx8 *a, int *lda, cpx8 *b, int *ldb, int *jpvt, float *rcond, int *rank, cpx8 *work, float *rwork, int *info);
  void cgeql2_(int *m, int *n, cpx8 *a, int *lda, cpx8 *tau, cpx8 *work, int *info);
  void cgeqlf_(int *m, int *n, cpx8 *a, int *lda, cpx8 *tau, cpx8 *work, int *lwork, int *info);
  void cgeqr2_(int *m, int *n, cpx8 *a, int *lda, cpx8 *tau, cpx8 *work, int *info);
  void cgeqrf_(int *m, int *n, cpx8 *a, int *lda, cpx8 *tau, cpx8 *work, int *lwork, int *info);
  void cgerfs_(char *trans, int *n, int *nrhs, cpx8 *a, int *lda, cpx8 *af, int *ldaf, int *ipiv, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void cgerq2_(int *m, int *n, cpx8 *a, int *lda, cpx8 *tau, cpx8 *work, int *info);
  void cgerqf_(int *m, int *n, cpx8 *a, int *lda, cpx8 *tau, cpx8 *work, int *lwork, int *info);
  void cgesv_(int *n, int *nrhs, cpx8 *a, int *lda, int *ipiv, cpx8 *b, int *ldb, int *info);
  void cgesvd_(char *jobu, char *jobvt, int *m, int *n, cpx8 *a, int *lda, float *s, cpx8 *u, int *ldu, cpx8 *vt, int *ldvt, cpx8 *work, int *lwork, float *rwork, int *info);
  void cgesvx_(char *fact, char *trans, int *n, int *nrhs, cpx8 *a, int *lda, cpx8 *af, int *ldaf, int *ipiv, char *equed, float *r, float *c, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *rcond, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void cgetf2_(int *m, int *n, cpx8 *a, int *lda, int *ipiv, int *info);
  void cgetrf_(int *m, int *n, cpx8 *a, int *lda, int *ipiv, int *info);
  void cgetri_(int *n, cpx8 *a, int *lda, int *ipiv, cpx8 *work, int *lwork, int *info);
  void cgetrs_(char *trans, int *n, int *nrhs, cpx8 *a, int *lda, int *ipiv, cpx8 *b, int *ldb, int *info);
  void cggbak_(char *job, char *side, int *n, int *ilo, int *ihi, float *lscale, float *rscale, int *m, cpx8 *v, int *ldv, int *info);
  void cggbal_(char *job, int *n, cpx8 *a, int *lda, cpx8 *b, int *ldb, int *ilo, int *ihi, float *lscale, float *rscale, float *work, int *info);
  void cggglm_(int *n, int *m, int *p, cpx8 *a, int *lda, cpx8 *b, int *ldb, cpx8 *d, cpx8 *x, cpx8 *y, cpx8 *work, int *lwork, int *info);
  void cgghrd_(char *compq, char *compz, int *n, int *ilo, int *ihi, cpx8 *a, int *lda, cpx8 *b, int *ldb, cpx8 *q, int *ldq, cpx8 *z, int *ldz, int *info);
  void cgglse_(int *m, int *n, int *p, cpx8 *a, int *lda, cpx8 *b, int *ldb, cpx8 *c, cpx8 *d, cpx8 *x, cpx8 *work, int *lwork, int *info);
  void cggqrf_(int *n, int *m, int *p, cpx8 *a, int *lda, cpx8 *taua, cpx8 *b, int *ldb, cpx8 *taub, cpx8 *work, int *lwork, int *info);
  void cggrqf_(int *m, int *p, int *n, cpx8 *a, int *lda, cpx8 *taua, cpx8 *b, int *ldb, cpx8 *taub, cpx8 *work, int *lwork, int *info);
  void cggsvd_(char *jobu, char *jobv, char *jobq, int *m, int *n, int *p, int *k, int *l, cpx8 *a, int *lda, cpx8 *b, int *ldb, float *alpha, float *beta, cpx8 *u, int *ldu, cpx8 *v, int *ldv, cpx8 *q, int *ldq, cpx8 *work, float *rwork, int *iwork, int *info);
  void cggsvp_(char *jobu, char *jobv, char *jobq, int *m, int *p, int *n, cpx8 *a, int *lda, cpx8 *b, int *ldb, float *tola, float *tolb, int *k, int *l, cpx8 *u, int *ldu, cpx8 *v, int *ldv, cpx8 *q, int *ldq, int *iwork, float *rwork, cpx8 *tau, cpx8 *work, int *info);
  void cgtcon_(char *norm, int *n, cpx8 *dl, cpx8 *d, cpx8 *du, cpx8 *du2, int *ipiv, float *anorm, float *rcond, cpx8 *work, int *info);
  void cgtrfs_(char *trans, int *n, int *nrhs, cpx8 *dl, cpx8 *d, cpx8 *du, cpx8 *dlf, cpx8 *df, cpx8 *duf, cpx8 *du2, int *ipiv, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void cgtsv_(int *n, int *nrhs, cpx8 *dl, cpx8 *d, cpx8 *du, cpx8 *b, int *ldb, int *info);
  void cgtsvx_(char *fact, char *trans, int *n, int *nrhs, cpx8 *dl, cpx8 *d, cpx8 *du, cpx8 *dlf, cpx8 *df, cpx8 *duf, cpx8 *du2, int *ipiv, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *rcond, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void cgttrf_(int *n, cpx8 *dl, cpx8 *d, cpx8 *du, cpx8 *du2, int *ipiv, int *info);
  void cgttrs_(char *trans, int *n, int *nrhs, cpx8 *dl, cpx8 *d, cpx8 *du, cpx8 *du2, int *ipiv, cpx8 *b, int *ldb, int *info);
  void chbev_(char *jobz, char *uplo, int *n, int *kd, cpx8 *ab, int *ldab, float *w, cpx8 *z, int *ldz, cpx8 *work, float *rwork, int *info);
  void chbevd_(char *jobz, char *uplo, int *n, int *kd, cpx8 *ab, int *ldab, float *w, cpx8 *z, int *ldz, cpx8 *work, int *lwork, float *rwork, int *lrwork, int *iwork, int *liwork, int *info);
  void chbevx_(char *jobz, char *range, char *uplo, int *n, int *kd, cpx8 *ab, int *ldab, cpx8 *q, int *ldq, float *vl, float *vu, int *il, int *iu, float *abstol, int *m, float *w, cpx8 *z, int *ldz, cpx8 *work, float *rwork, int *iwork, int *ifail, int *info);
  void chbgst_(char *vect, char *uplo, int *n, int *ka, int *kb, cpx8 *ab, int *ldab, cpx8 *bb, int *ldbb, cpx8 *x, int *ldx, cpx8 *work, float *rwork, int *info);
  void chbgv_(char *jobz, char *uplo, int *n, int *ka, int *kb, cpx8 *ab, int *ldab, cpx8 *bb, int *ldbb, float *w, cpx8 *z, int *ldz, cpx8 *work, float *rwork, int *info);
  void chbtrd_(char *vect, char *uplo, int *n, int *kd, cpx8 *ab, int *ldab, float *d, float *e, cpx8 *q, int *ldq, cpx8 *work, int *info);
  void checon_(char *uplo, int *n, cpx8 *a, int *lda, int *ipiv, float *anorm, float *rcond, cpx8 *work, int *info);
  void cheev_(char *jobz, char *uplo, int *n, cpx8 *a, int *lda, float *w, cpx8 *work, int *lwork, float *rwork, int *info);
  void cheevd_(char *jobz, char *uplo, int *n, cpx8 *a, int *lda, float *w, cpx8 *work, int *lwork, float *rwork, int *lrwork, int *iwork, int *liwork, int *info);
  void cheevx_(char *jobz, char *range, char *uplo, int *n, cpx8 *a, int *lda, float *vl, float *vu, int *il, int *iu, float *abstol, int *m, float *w, cpx8 *z, int *ldz, cpx8 *work, int *lwork, float *rwork, int *iwork, int *ifail, int *info);
  void chegs2_(int *itype, char *uplo, int *n, cpx8 *a, int *lda, cpx8 *b, int *ldb, int *info);
  void chegst_(int *itype, char *uplo, int *n, cpx8 *a, int *lda, cpx8 *b, int *ldb, int *info);
  void chegv_(int *itype, char *jobz, char *uplo, int *n, cpx8 *a, int *lda, cpx8 *b, int *ldb, float *w, cpx8 *work, int *lwork, float *rwork, int *info);
  void cherfs_(char *uplo, int *n, int *nrhs, cpx8 *a, int *lda, cpx8 *af, int *ldaf, int *ipiv, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void chesv_(char *uplo, int *n, int *nrhs, cpx8 *a, int *lda, int *ipiv, cpx8 *b, int *ldb, cpx8 *work, int *lwork, int *info);
  void chesvx_(char *fact, char *uplo, int *n, int *nrhs, cpx8 *a, int *lda, cpx8 *af, int *ldaf, int *ipiv, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *rcond, float *ferr, float *berr, cpx8 *work, int *lwork, float *rwork, int *info);
  void chetd2_(char *uplo, int *n, cpx8 *a, int *lda, float *d, float *e, cpx8 *tau, int *info);
  void chetf2_(char *uplo, int *n, cpx8 *a, int *lda, int *ipiv, int *info);
  void chetrd_(char *uplo, int *n, cpx8 *a, int *lda, float *d, float *e, cpx8 *tau, cpx8 *work, int *lwork, int *info);
  void chetrf_(char *uplo, int *n, cpx8 *a, int *lda, int *ipiv, cpx8 *work, int *lwork, int *info);
  void chetri_(char *uplo, int *n, cpx8 *a, int *lda, int *ipiv, cpx8 *work, int *info);
  void chetrs_(char *uplo, int *n, int *nrhs, cpx8 *a, int *lda, int *ipiv, cpx8 *b, int *ldb, int *info);
  void chgeqz_(char *job, char *compq, char *compz, int *n, int *ilo, int *ihi, cpx8 *a, int *lda, cpx8 *b, int *ldb, cpx8 *alpha, cpx8 *beta, cpx8 *q, int *ldq, cpx8 *z, int *ldz, cpx8 *work, int *lwork, float *rwork, int *info);
  void chpcon_(char *uplo, int *n, cpx8 *ap, int *ipiv, float *anorm, float *rcond, cpx8 *work, int *info);
  void chpev_(char *jobz, char *uplo, int *n, cpx8 *ap, float *w, cpx8 *z, int *ldz, cpx8 *work, float *rwork, int *info);
  void chpevd_(char *jobz, char *uplo, int *n, cpx8 *ap, float *w, cpx8 *z, int *ldz, cpx8 *work, int *lwork, float *rwork, int *lrwork, int *iwork, int *liwork, int *info);
  void chpevx_(char *jobz, char *range, char *uplo, int *n, cpx8 *ap, float *vl, float *vu, int *il, int *iu, float *abstol, int *m, float *w, cpx8 *z, int *ldz, cpx8 *work, float *rwork, int *iwork, int *ifail, int *info);
  void chpgst_(int *itype, char *uplo, int *n, cpx8 *ap, cpx8 *bp, int *info);
  void chpgv_(int *itype, char *jobz, char *uplo, int *n, cpx8 *ap, cpx8 *bp, float *w, cpx8 *z, int *ldz, cpx8 *work, float *rwork, int *info);
  void chprfs_(char *uplo, int *n, int *nrhs, cpx8 *ap, cpx8 *afp, int *ipiv, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void chpsv_(char *uplo, int *n, int *nrhs, cpx8 *ap, int *ipiv, cpx8 *b, int *ldb, int *info);
  void chpsvx_(char *fact, char *uplo, int *n, int *nrhs, cpx8 *ap, cpx8 *afp, int *ipiv, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *rcond, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void chptrd_(char *uplo, int *n, cpx8 *ap, float *d, float *e, cpx8 *tau, int *info);
  void chptrf_(char *uplo, int *n, cpx8 *ap, int *ipiv, int *info);
  void chptri_(char *uplo, int *n, cpx8 *ap, int *ipiv, cpx8 *work, int *info);
  void chptrs_(char *uplo, int *n, int *nrhs, cpx8 *ap, int *ipiv, cpx8 *b, int *ldb, int *info);
  void chsein_(char *side, char *eigsrc, char *initv, int *select, int *n, cpx8 *h, int *ldh, cpx8 *w, cpx8 *vl, int *ldvl, cpx8 *vr, int *ldvr, int *mm, int *m, cpx8 *work, float *rwork, int *ifaill, int *ifailr, int *info);
  void chseqr_(char *job, char *compz, int *n, int *ilo, int *ihi, cpx8 *h, int *ldh, cpx8 *w, cpx8 *z, int *ldz, cpx8 *work, int *lwork, int *info);
  void claed0_(int *qsiz, int *n, float *d, float *e, cpx8 *q, int *ldq, cpx8 *qstore, int *ldqs, float *rwork, int *iwork, int *info);
  void claed7_(int *n, int *cutpnt, int *qsiz, int *tlvls, int *curlvl, int *curpbm, float *d, cpx8 *q, int *ldq, float *rho, int *indxq, float *qstore, int *qptr, int *prmptr, int *perm, int *givptr, int *givcol, float *givnum, cpx8 *work, float *rwork, int *iwork, int *info);
  void claed8_(int *k, int *n, int *qsiz, cpx8 *q, int *ldq, float *d, float *rho, int *cutpnt, float *z, float *dlamda, cpx8 *q2, int *ldq2, float *w, int *indxp, int *indx, int *indxq, int *perm, int *givptr, int *givcol, float *givnum, int *info);
  void clahef_(char *uplo, int *n, int *nb, int *kb, cpx8 *a, int *lda, int *ipiv, cpx8 *w, int *ldw, int *info);
  void clasyf_(char *uplo, int *n, int *nb, int *kb, cpx8 *a, int *lda, int *ipiv, cpx8 *w, int *ldw, int *info);
  void clatzm_(char *side, int *m, int *n, cpx8 *v, int *incv, cpx8 *tau, cpx8 *c1, cpx8 *c2, int *ldc, cpx8 *work);
  void cpbcon_(char *uplo, int *n, int *kd, cpx8 *ab, int *ldab, float *anorm, float *rcond, cpx8 *work, float *rwork, int *info);
  void cpbequ_(char *uplo, int *n, int *kd, cpx8 *ab, int *ldab, float *s, float *scond, float *amax, int *info);
  void cpbrfs_(char *uplo, int *n, int *kd, int *nrhs, cpx8 *ab, int *ldab, cpx8 *afb, int *ldafb, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void cpbstf_(char *uplo, int *n, int *kd, cpx8 *ab, int *ldab, int *info);
  void cpbsv_(char *uplo, int *n, int *kd, int *nrhs, cpx8 *ab, int *ldab, cpx8 *b, int *ldb, int *info);
  void cpbsvx_(char *fact, char *uplo, int *n, int *kd, int *nrhs, cpx8 *ab, int *ldab, cpx8 *afb, int *ldafb, char *equed, float *s, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *rcond, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void cpbtf2_(char *uplo, int *n, int *kd, cpx8 *ab, int *ldab, int *info);
  void cpbtrf_(char *uplo, int *n, int *kd, cpx8 *ab, int *ldab, int *info);
  void cpbtrs_(char *uplo, int *n, int *kd, int *nrhs, cpx8 *ab, int *ldab, cpx8 *b, int *ldb, int *info);
  void cpocon_(char *uplo, int *n, cpx8 *a, int *lda, float *anorm, float *rcond, cpx8 *work, float *rwork, int *info);
  void cpoequ_(int *n, cpx8 *a, int *lda, float *s, float *scond, float *amax, int *info);
  void cporfs_(char *uplo, int *n, int *nrhs, cpx8 *a, int *lda, cpx8 *af, int *ldaf, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void cposv_(char *uplo, int *n, int *nrhs, cpx8 *a, int *lda, cpx8 *b, int *ldb, int *info);
  void cposvx_(char *fact, char *uplo, int *n, int *nrhs, cpx8 *a, int *lda, cpx8 *af, int *ldaf, char *equed, float *s, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *rcond, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void cpotf2_(char *uplo, int *n, cpx8 *a, int *lda, int *info);
  void cpotrf_(char *uplo, int *n, cpx8 *a, int *lda, int *info);
  void cpotri_(char *uplo, int *n, cpx8 *a, int *lda, int *info);
  void cpotrs_(char *uplo, int *n, int *nrhs, cpx8 *a, int *lda, cpx8 *b, int *ldb, int *info);
  void cppcon_(char *uplo, int *n, cpx8 *ap, float *anorm, float *rcond, cpx8 *work, float *rwork, int *info);
  void cppequ_(char *uplo, int *n, cpx8 *ap, float *s, float *scond, float *amax, int *info);
  void cpprfs_(char *uplo, int *n, int *nrhs, cpx8 *ap, cpx8 *afp, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void cppsv_(char *uplo, int *n, int *nrhs, cpx8 *ap, cpx8 *b, int *ldb, int *info);
  void cppsvx_(char *fact, char *uplo, int *n, int *nrhs, cpx8 *ap, cpx8 *afp, char *equed, float *s, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *rcond, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void cpptrf_(char *uplo, int *n, cpx8 *ap, int *info);
  void cpptri_(char *uplo, int *n, cpx8 *ap, int *info);
  void cpptrs_(char *uplo, int *n, int *nrhs, cpx8 *ap, cpx8 *b, int *ldb, int *info);
  void cptcon_(int *n, float *d, cpx8 *e, float *anorm, float *rcond, float *rwork, int *info);
  void cpteqr_(char *compz, int *n, float *d, float *e, cpx8 *z, int *ldz, float *work, int *info);
  void cptrfs_(char *uplo, int *n, int *nrhs, float *d, cpx8 *e, float *df, cpx8 *ef, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void cptsv_(int *n, int *nrhs, float *d, cpx8 *e, cpx8 *b, int *ldb, int *info);
  void cptsvx_(char *fact, int *n, int *nrhs, float *d, cpx8 *e, float *df, cpx8 *ef, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *rcond, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void cpttrf_(int *n, float *d, cpx8 *e, int *info);
  void cpttrs_(char *uplo, int *n, int *nrhs, float *d, cpx8 *e, cpx8 *b, int *ldb, int *info);
  void cspcon_(char *uplo, int *n, cpx8 *ap, int *ipiv, float *anorm, float *rcond, cpx8 *work, int *info);
  void csprfs_(char *uplo, int *n, int *nrhs, cpx8 *ap, cpx8 *afp, int *ipiv, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void cspsv_(char *uplo, int *n, int *nrhs, cpx8 *ap, int *ipiv, cpx8 *b, int *ldb, int *info);
  void cspsvx_(char *fact, char *uplo, int *n, int *nrhs, cpx8 *ap, cpx8 *afp, int *ipiv, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *rcond, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void csptrf_(char *uplo, int *n, cpx8 *ap, int *ipiv, int *info);
  void csptri_(char *uplo, int *n, cpx8 *ap, int *ipiv, cpx8 *work, int *info);
  void csptrs_(char *uplo, int *n, int *nrhs, cpx8 *ap, int *ipiv, cpx8 *b, int *ldb, int *info);
  void csrot_(int *n, cpx8 *cx, int *incx, cpx8 *cy, int *incy, float *c, float *s);
  void cstedc_(char *compz, int *n, float *d, float *e, cpx8 *z, int *ldz, cpx8 *work, int *lwork, float *rwork, int *lrwork, int *iwork, int *liwork, int *info);
  void cstein_(int *n, float *d, float *e, int *m, float *w, int *iblock, int *isplit, cpx8 *z, int *ldz, float *work, int *iwork, int *ifail, int *info);
  void csteqr_(char *compz, int *n, float *d, float *e, cpx8 *z, int *ldz, float *work, int *info);
  void csycon_(char *uplo, int *n, cpx8 *a, int *lda, int *ipiv, float *anorm, float *rcond, cpx8 *work, int *info);
  void csyrfs_(char *uplo, int *n, int *nrhs, cpx8 *a, int *lda, cpx8 *af, int *ldaf, int *ipiv, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void csysv_(char *uplo, int *n, int *nrhs, cpx8 *a, int *lda, int *ipiv, cpx8 *b, int *ldb, cpx8 *work, int *lwork, int *info);
  void csysvx_(char *fact, char *uplo, int *n, int *nrhs, cpx8 *a, int *lda, cpx8 *af, int *ldaf, int *ipiv, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *rcond, float *ferr, float *berr, cpx8 *work, int *lwork, float *rwork, int *info);
  void csytf2_(char *uplo, int *n, cpx8 *a, int *lda, int *ipiv, int *info);
  void csytrf_(char *uplo, int *n, cpx8 *a, int *lda, int *ipiv, cpx8 *work, int *lwork, int *info);
  void csytri_(char *uplo, int *n, cpx8 *a, int *lda, int *ipiv, cpx8 *work, int *info);
  void csytrs_(char *uplo, int *n, int *nrhs, cpx8 *a, int *lda, int *ipiv, cpx8 *b, int *ldb, int *info);
  void ctbcon_(char *norm, char *uplo, char *diag, int *n, int *kd, cpx8 *ab, int *ldab, float *rcond, cpx8 *work, float *rwork, int *info);
  void ctbrfs_(char *uplo, char *trans, char *diag, int *n, int *kd, int *nrhs, cpx8 *ab, int *ldab, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void ctbtrs_(char *uplo, char *trans, char *diag, int *n, int *kd, int *nrhs, cpx8 *ab, int *ldab, cpx8 *b, int *ldb, int *info);
  void ctgevc_(char *side, char *howmny, int *select, int *n, cpx8 *a, int *lda, cpx8 *b, int *ldb, cpx8 *vl, int *ldvl, cpx8 *vr, int *ldvr, int *mm, int *m, cpx8 *work, float *rwork, int *info);
  void ctgsja_(char *jobu, char *jobv, char *jobq, int *m, int *p, int *n, int *k, int *l, cpx8 *a, int *lda, cpx8 *b, int *ldb, float *tola, float *tolb, float *alpha, float *beta, cpx8 *u, int *ldu, cpx8 *v, int *ldv, cpx8 *q, int *ldq, cpx8 *work, int *ncycle, int *info);
  void ctpcon_(char *norm, char *uplo, char *diag, int *n, cpx8 *ap, float *rcond, cpx8 *work, float *rwork, int *info);
  void ctprfs_(char *uplo, char *trans, char *diag, int *n, int *nrhs, cpx8 *ap, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void ctptri_(char *uplo, char *diag, int *n, cpx8 *ap, int *info);
  void ctptrs_(char *uplo, char *trans, char *diag, int *n, int *nrhs, cpx8 *ap, cpx8 *b, int *ldb, int *info);
  void ctrcon_(char *norm, char *uplo, char *diag, int *n, cpx8 *a, int *lda, float *rcond, cpx8 *work, float *rwork, int *info);
  void ctrevc_(char *side, char *howmny, int *select, int *n, cpx8 *t, int *ldt, cpx8 *vl, int *ldvl, cpx8 *vr, int *ldvr, int *mm, int *m, cpx8 *work, float *rwork, int *info);
  void ctrexc_(char *compq, int *n, cpx8 *t, int *ldt, cpx8 *q, int *ldq, int *ifst, int *ilst, int *info);
  void ctrrfs_(char *uplo, char *trans, char *diag, int *n, int *nrhs, cpx8 *a, int *lda, cpx8 *b, int *ldb, cpx8 *x, int *ldx, float *ferr, float *berr, cpx8 *work, float *rwork, int *info);
  void ctrsen_(char *job, char *compq, int *select, int *n, cpx8 *t, int *ldt, cpx8 *q, int *ldq, cpx8 *w, int *m, float *s, float *sep, cpx8 *work, int *lwork, int *info);
  void ctrsna_(char *job, char *howmny, int *select, int *n, cpx8 *t, int *ldt, cpx8 *vl, int *ldvl, cpx8 *vr, int *ldvr, float *s, float *sep, int *mm, int *m, cpx8 *work, int *ldwork, float *rwork, int *info);
  void ctrsyl_(char *trana, char *tranb, int *isgn, int *m, int *n, cpx8 *a, int *lda, cpx8 *b, int *ldb, cpx8 *c, int *ldc, float *scale, int *info);
  void ctrti2_(char *uplo, char *diag, int *n, cpx8 *a, int *lda, int *info);
  void ctrtri_(char *uplo, char *diag, int *n, cpx8 *a, int *lda, int *info);
  void ctrtrs_(char *uplo, char *trans, char *diag, int *n, int *nrhs, cpx8 *a, int *lda, cpx8 *b, int *ldb, int *info);
  void ctzrqf_(int *m, int *n, cpx8 *a, int *lda, cpx8 *tau, int *info);
  void cung2l_(int *m, int *n, int *k, cpx8 *a, int *lda, cpx8 *tau, cpx8 *work, int *info);
  void cung2r_(int *m, int *n, int *k, cpx8 *a, int *lda, cpx8 *tau, cpx8 *work, int *info);
  void cungbr_(char *vect, int *m, int *n, int *k, cpx8 *a, int *lda, cpx8 *tau, cpx8 *work, int *lwork, int *info);
  void cunghr_(int *n, int *ilo, int *ihi, cpx8 *a, int *lda, cpx8 *tau, cpx8 *work, int *lwork, int *info);
  void cungl2_(int *m, int *n, int *k, cpx8 *a, int *lda, cpx8 *tau, cpx8 *work, int *info);
  void cunglq_(int *m, int *n, int *k, cpx8 *a, int *lda, cpx8 *tau, cpx8 *work, int *lwork, int *info);
  void cungql_(int *m, int *n, int *k, cpx8 *a, int *lda, cpx8 *tau, cpx8 *work, int *lwork, int *info);
  void cungqr_(int *m, int *n, int *k, cpx8 *a, int *lda, cpx8 *tau, cpx8 *work, int *lwork, int *info);
  void cungr2_(int *m, int *n, int *k, cpx8 *a, int *lda, cpx8 *tau, cpx8 *work, int *info);
  void cungrq_(int *m, int *n, int *k, cpx8 *a, int *lda, cpx8 *tau, cpx8 *work, int *lwork, int *info);
  void cungtr_(char *uplo, int *n, cpx8 *a, int *lda, cpx8 *tau, cpx8 *work, int *lwork, int *info);
  void cunm2l_(char *side, char *trans, int *m, int *n, int *k, cpx8 *a, int *lda, cpx8 *tau, cpx8 *c, int *ldc, cpx8 *work, int *info);
  void cunm2r_(char *side, char *trans, int *m, int *n, int *k, cpx8 *a, int *lda, cpx8 *tau, cpx8 *c, int *ldc, cpx8 *work, int *info);
  void cunmbr_(char *vect, char *side, char *trans, int *m, int *n, int *k, cpx8 *a, int *lda, cpx8 *tau, cpx8 *c, int *ldc, cpx8 *work, int *lwork, int *info);
  void cunmhr_(char *side, char *trans, int *m, int *n, int *ilo, int *ihi, cpx8 *a, int *lda, cpx8 *tau, cpx8 *c, int *ldc, cpx8 *work, int *lwork, int *info);
  void cunml2_(char *side, char *trans, int *m, int *n, int *k, cpx8 *a, int *lda, cpx8 *tau, cpx8 *c, int *ldc, cpx8 *work, int *info);
  void cunmlq_(char *side, char *trans, int *m, int *n, int *k, cpx8 *a, int *lda, cpx8 *tau, cpx8 *c, int *ldc, cpx8 *work, int *lwork, int *info);
  void cunmql_(char *side, char *trans, int *m, int *n, int *k, cpx8 *a, int *lda, cpx8 *tau, cpx8 *c, int *ldc, cpx8 *work, int *lwork, int *info);
  void cunmqr_(char *side, char *trans, int *m, int *n, int *k, cpx8 *a, int *lda, cpx8 *tau, cpx8 *c, int *ldc, cpx8 *work, int *lwork, int *info);
  void cunmr2_(char *side, char *trans, int *m, int *n, int *k, cpx8 *a, int *lda, cpx8 *tau, cpx8 *c, int *ldc, cpx8 *work, int *info);
  void cunmrq_(char *side, char *trans, int *m, int *n, int *k, cpx8 *a, int *lda, cpx8 *tau, cpx8 *c, int *ldc, cpx8 *work, int *lwork, int *info);
  void cunmtr_(char *side, char *uplo, char *trans, int *m, int *n, cpx8 *a, int *lda, cpx8 *tau, cpx8 *c, int *ldc, cpx8 *work, int *lwork, int *info);
  void cupgtr_(char *uplo, int *n, cpx8 *ap, cpx8 *tau, cpx8 *q, int *ldq, cpx8 *work, int *info);
  void cupmtr_(char *side, char *uplo, char *trans, int *m, int *n, cpx8 *ap, cpx8 *tau, cpx8 *c, int *ldc, cpx8 *work, int *info);
  void sbdsqr_(char *uplo, int *n, int *ncvt, int *nru, int *ncc, float *d, float *e, float *vt, int *ldvt, float *u, int *ldu, float *c, int *ldc, float *work, int *info);
  void sdisna_(char *job, int *m, int *n, float *d, float *sep, int *info);
  void sgbbrd_(char *vect, int *m, int *n, int *ncc, int *kl, int *ku, float *ab, int *ldab, float *d, float *e, float *q, int *ldq, float *pt, int *ldpt, float *c, int *ldc, float *work, int *info);
  void sgbcon_(char *norm, int *n, int *kl, int *ku, float *ab, int *ldab, int *ipiv, float *anorm, float *rcond, float *work, int *iwork, int *info);
  void sgbequ_(int *m, int *n, int *kl, int *ku, float *ab, int *ldab, float *r, float *c, float *rowcnd, float *colcnd, float *amax, int *info);
  void sgbrfs_(char *trans, int *n, int *kl, int *ku, int *nrhs, float *ab, int *ldab, float *afb, int *ldafb, int *ipiv, float *b, int *ldb, float *x, int *ldx, float *ferr, float *berr, float *work, int *iwork, int *info);
  void sgbsv_(int *n, int *kl, int *ku, int *nrhs, float *ab, int *ldab, int *ipiv, float *b, int *ldb, int *info);
  void sgbsvx_(char *fact, char *trans, int *n, int *kl, int *ku, int *nrhs, float *ab, int *ldab, float *afb, int *ldafb, int *ipiv, char *equed, float *r, float *c, float *b, int *ldb, float *x, int *ldx, float *rcond, float *ferr, float *berr, float *work, int *iwork, int *info);
  void sgbtf2_(int *m, int *n, int *kl, int *ku, float *ab, int *ldab, int *ipiv, int *info);
  void sgbtrf_(int *m, int *n, int *kl, int *ku, float *ab, int *ldab, int *ipiv, int *info);
  void sgbtrs_(char *trans, int *n, int *kl, int *ku, int *nrhs, float *ab, int *ldab, int *ipiv, float *b, int *ldb, int *info);
  void sgebak_(char *job, char *side, int *n, int *ilo, int *ihi, float *scale, int *m, float *v, int *ldv, int *info);
  void sgebal_(char *job, int *n, float *a, int *lda, int *ilo, int *ihi, float *scale, int *info);
  void sgebd2_(int *m, int *n, float *a, int *lda, float *d, float *e, float *tauq, float *taup, float *work, int *info);
  void sgebrd_(int *m, int *n, float *a, int *lda, float *d, float *e, float *tauq, float *taup, float *work, int *lwork, int *info);
  void sgecon_(char *norm, int *n, float *a, int *lda, float *anorm, float *rcond, float *work, int *iwork, int *info);
  void sgeequ_(int *m, int *n, float *a, int *lda, float *r, float *c, float *rowcnd, float *colcnd, float *amax, int *info);
  void sgees_(char *jobvs, char *sort, int *select, int *n, float *a, int *lda, int *sdim, float *wr, float *wi, float *vs, int *ldvs, float *work, int *lwork, int *bwork, int *info);
  void sgeesx_(char *jobvs, char *sort, int *select, char *sense, int *n, float *a, int *lda, int *sdim, float *wr, float *wi, float *vs, int *ldvs, float *rconde, float *rcondv, float *work, int *lwork, int *iwork, int *liwork, int *bwork, int *info);
  void sgeev_(char *jobvl, char *jobvr, int *n, float *a, int *lda, float *wr, float *wi, float *vl, int *ldvl, float *vr, int *ldvr, float *work, int *lwork, int *info);
  void sgeevx_(char *balanc, char *jobvl, char *jobvr, char *sense, int *n, float *a, int *lda, float *wr, float *wi, float *vl, int *ldvl, float *vr, int *ldvr, int *ilo, int *ihi, float *scale, float *abnrm, float *rconde, float *rcondv, float *work, int *lwork, int *iwork, int *info);
  void sgegs_(char *jobvsl, char *jobvsr, int *n, float *a, int *lda, float *b, int *ldb, float *alphar, float *alphai, float *beta, float *vsl, int *ldvsl, float *vsr, int *ldvsr, float *work, int *lwork, int *info);
  void sgegv_(char *jobvl, char *jobvr, int *n, float *a, int *lda, float *b, int *ldb, float *alphar, float *alphai, float *beta, float *vl, int *ldvl, float *vr, int *ldvr, float *work, int *lwork, int *info);
  void sgehd2_(int *n, int *ilo, int *ihi, float *a, int *lda, float *tau, float *work, int *info);
  void sgehrd_(int *n, int *ilo, int *ihi, float *a, int *lda, float *tau, float *work, int *lwork, int *info);
  void sgelq2_(int *m, int *n, float *a, int *lda, float *tau, float *work, int *info);
  void sgelqf_(int *m, int *n, float *a, int *lda, float *tau, float *work, int *lwork, int *info);
  void sgels_(char *trans, int *m, int *n, int *nrhs, float *a, int *lda, float *b, int *ldb, float *work, int *lwork, int *info);
  void sgelss_(int *m, int *n, int *nrhs, float *a, int *lda, float *b, int *ldb, float *s, float *rcond, int *rank, float *work, int *lwork, int *info);
  void sgelsx_(int *m, int *n, int *nrhs, float *a, int *lda, float *b, int *ldb, int *jpvt, float *rcond, int *rank, float *work, int *info);
  void sgeql2_(int *m, int *n, float *a, int *lda, float *tau, float *work, int *info);
  void sgeqlf_(int *m, int *n, float *a, int *lda, float *tau, float *work, int *lwork, int *info);
  void sgeqpf_(int *m, int *n, float *a, int *lda, int *jpvt, float *tau, float *work, int *info);
  void sgeqr2_(int *m, int *n, float *a, int *lda, float *tau, float *work, int *info);
  void sgeqrf_(int *m, int *n, float *a, int *lda, float *tau, float *work, int *lwork, int *info);
  void sgerfs_(char *trans, int *n, int *nrhs, float *a, int *lda, float *af, int *ldaf, int *ipiv, float *b, int *ldb, float *x, int *ldx, float *ferr, float *berr, float *work, int *iwork, int *info);
  void sgerq2_(int *m, int *n, float *a, int *lda, float *tau, float *work, int *info);
  void sgerqf_(int *m, int *n, float *a, int *lda, float *tau, float *work, int *lwork, int *info);
  void sgesv_(int *n, int *nrhs, float *a, int *lda, int *ipiv, float *b, int *ldb, int *info);
  void sgesvd_(char *jobu, char *jobvt, int *m, int *n, float *a, int *lda, float *s, float *u, int *ldu, float *vt, int *ldvt, float *work, int *lwork, int *info);
  void sgesvx_(char *fact, char *trans, int *n, int *nrhs, float *a, int *lda, float *af, int *ldaf, int *ipiv, char *equed, float *r, float *c, float *b, int *ldb, float *x, int *ldx, float *rcond, float *ferr, float *berr, float *work, int *iwork, int *info);
  void sgetf2_(int *m, int *n, float *a, int *lda, int *ipiv, int *info);
  void sgetrf_(int *m, int *n, float *a, int *lda, int *ipiv, int *info);
  void sgetri_(int *n, float *a, int *lda, int *ipiv, float *work, int *lwork, int *info);
  void sgetrs_(char *trans, int *n, int *nrhs, float *a, int *lda, int *ipiv, float *b, int *ldb, int *info);
  void sggbak_(char *job, char *side, int *n, int *ilo, int *ihi, float *lscale, float *rscale, int *m, float *v, int *ldv, int *info);
  void sggbal_(char *job, int *n, float *a, int *lda, float *b, int *ldb, int *ilo, int *ihi, float *lscale, float *rscale, float *work, int *info);
  void sggglm_(int *n, int *m, int *p, float *a, int *lda, float *b, int *ldb, float *d, float *x, float *y, float *work, int *lwork, int *info);
  void sgghrd_(char *compq, char *compz, int *n, int *ilo, int *ihi, float *a, int *lda, float *b, int *ldb, float *q, int *ldq, float *z, int *ldz, int *info);
  void sgglse_(int *m, int *n, int *p, float *a, int *lda, float *b, int *ldb, float *c, float *d, float *x, float *work, int *lwork, int *info);
  void sggqrf_(int *n, int *m, int *p, float *a, int *lda, float *taua, float *b, int *ldb, float *taub, float *work, int *lwork, int *info);
  void sggrqf_(int *m, int *p, int *n, float *a, int *lda, float *taua, float *b, int *ldb, float *taub, float *work, int *lwork, int *info);
  void sggsvd_(char *jobu, char *jobv, char *jobq, int *m, int *n, int *p, int *k, int *l, float *a, int *lda, float *b, int *ldb, float *alpha, float *beta, float *u, int *ldu, float *v, int *ldv, float *q, int *ldq, float *work, int *iwork, int *info);
  void sggsvp_(char *jobu, char *jobv, char *jobq, int *m, int *p, int *n, float *a, int *lda, float *b, int *ldb, float *tola, float *tolb, int *k, int *l, float *u, int *ldu, float *v, int *ldv, float *q, int *ldq, int *iwork, float *tau, float *work, int *info);
  void sgtcon_(char *norm, int *n, float *dl, float *d, float *du, float *du2, int *ipiv, float *anorm, float *rcond, float *work, int *iwork, int *info);
  void sgtrfs_(char *trans, int *n, int *nrhs, float *dl, float *d, float *du, float *dlf, float *df, float *duf, float *du2, int *ipiv, float *b, int *ldb, float *x, int *ldx, float *ferr, float *berr, float *work, int *iwork, int *info);
  void sgtsv_(int *n, int *nrhs, float *dl, float *d, float *du, float *b, int *ldb, int *info);
  void sgtsvx_(char *fact, char *trans, int *n, int *nrhs, float *dl, float *d, float *du, float *dlf, float *df, float *duf, float *du2, int *ipiv, float *b, int *ldb, float *x, int *ldx, float *rcond, float *ferr, float *berr, float *work, int *iwork, int *info);
  void sgttrf_(int *n, float *dl, float *d, float *du, float *du2, int *ipiv, int *info);
  void sgttrs_(char *trans, int *n, int *nrhs, float *dl, float *d, float *du, float *du2, int *ipiv, float *b, int *ldb, int *info);
  void shgeqz_(char *job, char *compq, char *compz, int *n, int *ilo, int *ihi, float *a, int *lda, float *b, int *ldb, float *alphar, float *alphai, float *beta, float *q, int *ldq, float *z, int *ldz, float *work, int *lwork, int *info);
  void shsein_(char *side, char *eigsrc, char *initv, int *select, int *n, float *h, int *ldh, float *wr, float *wi, float *vl, int *ldvl, float *vr, int *ldvr, int *mm, int *m, float *work, int *ifaill, int *ifailr, int *info);
  void shseqr_(char *job, char *compz, int *n, int *ilo, int *ihi, float *h, int *ldh, float *wr, float *wi, float *z, int *ldz, float *work, int *lwork, int *info);
  void slaed0_(int *icompq, int *qsiz, int *n, float *d, float *e, float *q, int *ldq, float *qstore, int *ldqs, float *work, int *iwork, int *info);
  void slaed1_(int *n, float *d, float *q, int *ldq, int *indxq, float *rho, int *cutpnt, float *work, int *iwork, int *info);
  void slaed2_(int *k, int *n, float *d, float *q, int *ldq, int *indxq, float *rho, int *cutpnt, float *z, float *dlamda, float *q2, int *ldq2, int *indxc, float *w, int *indxp, int *indx, int *coltyp, int *info);
  void slaed3_(int *k, int *kstart, int *kstop, int *n, float *d, float *q, int *ldq, float *rho, int *cutpnt, float *dlamda, float *q2, int *ldq2, int *indxc, int *ctot, float *w, float *s, int *lds, int *info);
  void slaed4_(int *n, int *i, float *d, float *z, float *delta, float *rho, float *dlam, int *info);
  void slaed5_(int *i, float *d, float *z, float *delta, float *rho, float *dlam);
  void slaed6_(int *kniter, int *orgati, float *rho, float *d, float *z, float *finit, float *tau, int *info);
  void slaed7_(int *icompq, int *n, int *qsiz, int *tlvls, int *curlvl, int *curpbm, float *d, float *q, int *ldq, int *indxq, float *rho, int *cutpnt, float *qstore, int *qptr, int *prmptr, int *perm, int *givptr, int *givcol, float *givnum, float *work, int *iwork, int *info);
  void slaed8_(int *icompq, int *k, int *n, int *qsiz, float *d, float *q, int *ldq, int *indxq, float *rho, int *cutpnt, float *z, float *dlamda, float *q2, int *ldq2, float *w, int *perm, int *givptr, int *givcol, float *givnum, int *indxp, int *indx, int *info);
  void slaed9_(int *k, int *kstart, int *kstop, int *n, float *d, float *q, int *ldq, float *rho, float *dlamda, float *w, float *s, int *lds, int *info);
  void slaeda_(int *n, int *tlvls, int *curlvl, int *curpbm, int *prmptr, int *perm, int *givptr, int *givcol, float *givnum, float *q, int *qptr, float *z, float *ztemp, int *info);
  void slagtf_(int *n, float *a, float *lambda, float *b, float *c, float *tol, float *d, int *in, int *info);
  void slamrg_(int *n1, int *n2, float *a, int *strd1, int *strd2, int *index);
  void slasq1_(int *n, float *d, float *e, float *work, int *info);
  void slasq2_(int *m, float *q, float *e, float *qq, float *ee, float *eps, float *tol2, float *small2, float *sup, int *kend, int *info);
  void slasq3_(int *n, float *q, float *e, float *qq, float *ee, float *sup, float *sigma, int *kend, int *off, int *iphase, int *iconv, float *eps, float *tol2, float *small2);
  void slasq4_(int *n, float *q, float *e, float *tau, float *sup);
  void slasrt_(char *id, int *n, float *d, int *info);
  void slatzm_(char *side, int *m, int *n, float *v, int *incv, float *tau, float *c1, float *c2, int *ldc, float *work);
  void sopgtr_(char *uplo, int *n, float *ap, float *tau, float *q, int *ldq, float *work, int *info);
  void sopmtr_(char *side, char *uplo, char *trans, int *m, int *n, float *ap, float *tau, float *c, int *ldc, float *work, int *info);
  void sorg2l_(int *m, int *n, int *k, float *a, int *lda, float *tau, float *work, int *info);
  void sorg2r_(int *m, int *n, int *k, float *a, int *lda, float *tau, float *work, int *info);
  void sorgbr_(char *vect, int *m, int *n, int *k, float *a, int *lda, float *tau, float *work, int *lwork, int *info);
  void sorghr_(int *n, int *ilo, int *ihi, float *a, int *lda, float *tau, float *work, int *lwork, int *info);
  void sorgl2_(int *m, int *n, int *k, float *a, int *lda, float *tau, float *work, int *info);
  void sorglq_(int *m, int *n, int *k, float *a, int *lda, float *tau, float *work, int *lwork, int *info);
  void sorgql_(int *m, int *n, int *k, float *a, int *lda, float *tau, float *work, int *lwork, int *info);
  void sorgqr_(int *m, int *n, int *k, float *a, int *lda, float *tau, float *work, int *lwork, int *info);
  void sorgr2_(int *m, int *n, int *k, float *a, int *lda, float *tau, float *work, int *info);
  void sorgrq_(int *m, int *n, int *k, float *a, int *lda, float *tau, float *work, int *lwork, int *info);
  void sorgtr_(char *uplo, int *n, float *a, int *lda, float *tau, float *work, int *lwork, int *info);
  void sorm2l_(char *side, char *trans, int *m, int *n, int *k, float *a, int *lda, float *tau, float *c, int *ldc, float *work, int *info);
  void sorm2r_(char *side, char *trans, int *m, int *n, int *k, float *a, int *lda, float *tau, float *c, int *ldc, float *work, int *info);
  void sormbr_(char *vect, char *side, char *trans, int *m, int *n, int *k, float *a, int *lda, float *tau, float *c, int *ldc, float *work, int *lwork, int *info);
  void sormhr_(char *side, char *trans, int *m, int *n, int *ilo, int *ihi, float *a, int *lda, float *tau, float *c, int *ldc, float *work, int *lwork, int *info);
  void sorml2_(char *side, char *trans, int *m, int *n, int *k, float *a, int *lda, float *tau, float *c, int *ldc, float *work, int *info);
  void sormlq_(char *side, char *trans, int *m, int *n, int *k, float *a, int *lda, float *tau, float *c, int *ldc, float *work, int *lwork, int *info);
  void sormql_(char *side, char *trans, int *m, int *n, int *k, float *a, int *lda, float *tau, float *c, int *ldc, float *work, int *lwork, int *info);
  void sormqr_(char *side, char *trans, int *m, int *n, int *k, float *a, int *lda, float *tau, float *c, int *ldc, float *work, int *lwork, int *info);
  void sormr2_(char *side, char *trans, int *m, int *n, int *k, float *a, int *lda, float *tau, float *c, int *ldc, float *work, int *info);
  void sormrq_(char *side, char *trans, int *m, int *n, int *k, float *a, int *lda, float *tau, float *c, int *ldc, float *work, int *lwork, int *info);
  void sormtr_(char *side, char *uplo, char *trans, int *m, int *n, float *a, int *lda, float *tau, float *c, int *ldc, float *work, int *lwork, int *info);
  void spbcon_(char *uplo, int *n, int *kd, float *ab, int *ldab, float *anorm, float *rcond, float *work, int *iwork, int *info);
  void spbequ_(char *uplo, int *n, int *kd, float *ab, int *ldab, float *s, float *scond, float *amax, int *info);
  void spbrfs_(char *uplo, int *n, int *kd, int *nrhs, float *ab, int *ldab, float *afb, int *ldafb, float *b, int *ldb, float *x, int *ldx, float *ferr, float *berr, float *work, int *iwork, int *info);
  void spbstf_(char *uplo, int *n, int *kd, float *ab, int *ldab, int *info);
  void spbsv_(char *uplo, int *n, int *kd, int *nrhs, float *ab, int *ldab, float *b, int *ldb, int *info);
  void spbsvx_(char *fact, char *uplo, int *n, int *kd, int *nrhs, float *ab, int *ldab, float *afb, int *ldafb, char *equed, float *s, float *b, int *ldb, float *x, int *ldx, float *rcond, float *ferr, float *berr, float *work, int *iwork, int *info);
  void spbtf2_(char *uplo, int *n, int *kd, float *ab, int *ldab, int *info);
  void spbtrf_(char *uplo, int *n, int *kd, float *ab, int *ldab, int *info);
  void spbtrs_(char *uplo, int *n, int *kd, int *nrhs, float *ab, int *ldab, float *b, int *ldb, int *info);
  void spocon_(char *uplo, int *n, float *a, int *lda, float *anorm, float *rcond, float *work, int *iwork, int *info);
  void spoequ_(int *n, float *a, int *lda, float *s, float *scond, float *amax, int *info);
  void sporfs_(char *uplo, int *n, int *nrhs, float *a, int *lda, float *af, int *ldaf, float *b, int *ldb, float *x, int *ldx, float *ferr, float *berr, float *work, int *iwork, int *info);
  void sposv_(char *uplo, int *n, int *nrhs, float *a, int *lda, float *b, int *ldb, int *info);
  void sposvx_(char *fact, char *uplo, int *n, int *nrhs, float *a, int *lda, float *af, int *ldaf, char *equed, float *s, float *b, int *ldb, float *x, int *ldx, float *rcond, float *ferr, float *berr, float *work, int *iwork, int *info);
  void spotf2_(char *uplo, int *n, float *a, int *lda, int *info);
  void spotrf_(char *uplo, int *n, float *a, int *lda, int *info);
  void spotri_(char *uplo, int *n, float *a, int *lda, int *info);
  void spotrs_(char *uplo, int *n, int *nrhs, float *a, int *lda, float *b, int *ldb, int *info);
  void sppcon_(char *uplo, int *n, float *ap, float *anorm, float *rcond, float *work, int *iwork, int *info);
  void sppequ_(char *uplo, int *n, float *ap, float *s, float *scond, float *amax, int *info);
  void spprfs_(char *uplo, int *n, int *nrhs, float *ap, float *afp, float *b, int *ldb, float *x, int *ldx, float *ferr, float *berr, float *work, int *iwork, int *info);
  void sppsv_(char *uplo, int *n, int *nrhs, float *ap, float *b, int *ldb, int *info);
  void sppsvx_(char *fact, char *uplo, int *n, int *nrhs, float *ap, float *afp, char *equed, float *s, float *b, int *ldb, float *x, int *ldx, float *rcond, float *ferr, float *berr, float *work, int *iwork, int *info);
  void spptrf_(char *uplo, int *n, float *ap, int *info);
  void spptri_(char *uplo, int *n, float *ap, int *info);
  void spptrs_(char *uplo, int *n, int *nrhs, float *ap, float *b, int *ldb, int *info);
  void sptcon_(int *n, float *d, float *e, float *anorm, float *rcond, float *work, int *info);
  void spteqr_(char *compz, int *n, float *d, float *e, float *z, int *ldz, float *work, int *info);
  void sptrfs_(int *n, int *nrhs, float *d, float *e, float *df, float *ef, float *b, int *ldb, float *x, int *ldx, float *ferr, float *berr, float *work, int *info);
  void sptsv_(int *n, int *nrhs, float *d, float *e, float *b, int *ldb, int *info);
  void sptsvx_(char *fact, int *n, int *nrhs, float *d, float *e, float *df, float *ef, float *b, int *ldb, float *x, int *ldx, float *rcond, float *ferr, float *berr, float *work, int *info);
  void spttrf_(int *n, float *d, float *e, int *info);
  void spttrs_(int *n, int *nrhs, float *d, float *e, float *b, int *ldb, int *info);
  void ssbev_(char *jobz, char *uplo, int *n, int *kd, float *ab, int *ldab, float *w, float *z, int *ldz, float *work, int *info);
  void ssbevd_(char *jobz, char *uplo, int *n, int *kd, float *ab, int *ldab, float *w, float *z, int *ldz, float *work, int *lwork, int *iwork, int *liwork, int *info);
  void ssbevx_(char *jobz, char *range, char *uplo, int *n, int *kd, float *ab, int *ldab, float *q, int *ldq, float *vl, float *vu, int *il, int *iu, float *abstol, int *m, float *w, float *z, int *ldz, float *work, int *iwork, int *ifail, int *info);
  void ssbgst_(char *vect, char *uplo, int *n, int *ka, int *kb, float *ab, int *ldab, float *bb, int *ldbb, float *x, int *ldx, float *work, int *info);
  void ssbgv_(char *jobz, char *uplo, int *n, int *ka, int *kb, float *ab, int *ldab, float *bb, int *ldbb, float *w, float *z, int *ldz, float *work, int *info);
  void ssbtrd_(char *vect, char *uplo, int *n, int *kd, float *ab, int *ldab, float *d, float *e, float *q, int *ldq, float *work, int *info);
  void sspcon_(char *uplo, int *n, float *ap, int *ipiv, float *anorm, float *rcond, float *work, int *iwork, int *info);
  void sspev_(char *jobz, char *uplo, int *n, float *ap, float *w, float *z, int *ldz, float *work, int *info);
  void sspevd_(char *jobz, char *uplo, int *n, float *ap, float *w, float *z, int *ldz, float *work, int *lwork, int *iwork, int *liwork, int *info);
  void sspevx_(char *jobz, char *range, char *uplo, int *n, float *ap, float *vl, float *vu, int *il, int *iu, float *abstol, int *m, float *w, float *z, int *ldz, float *work, int *iwork, int *ifail, int *info);
  void sspgst_(int *itype, char *uplo, int *n, float *ap, float *bp, int *info);
  void sspgv_(int *itype, char *jobz, char *uplo, int *n, float *ap, float *bp, float *w, float *z, int *ldz, float *work, int *info);
  void ssprfs_(char *uplo, int *n, int *nrhs, float *ap, float *afp, int *ipiv, float *b, int *ldb, float *x, int *ldx, float *ferr, float *berr, float *work, int *iwork, int *info);
  void sspsv_(char *uplo, int *n, int *nrhs, float *ap, int *ipiv, float *b, int *ldb, int *info);
  void sspsvx_(char *fact, char *uplo, int *n, int *nrhs, float *ap, float *afp, int *ipiv, float *b, int *ldb, float *x, int *ldx, float *rcond, float *ferr, float *berr, float *work, int *iwork, int *info);
  void ssptrd_(char *uplo, int *n, float *ap, float *d, float *e, float *tau, int *info);
  void ssptrf_(char *uplo, int *n, float *ap, int *ipiv, int *info);
  void ssptri_(char *uplo, int *n, float *ap, int *ipiv, float *work, int *info);
  void ssptrs_(char *uplo, int *n, int *nrhs, float *ap, int *ipiv, float *b, int *ldb, int *info);
  void sstebz_(char *range, char *order, int *n, float *vl, float *vu, int *il, int *iu, float *abstol, float *d, float *e, int *m, int *nsplit, float *w, int *iblock, int *isplit, float *work, int *iwork, int *info);
  void sstedc_(char *compz, int *n, float *d, float *e, float *z, int *ldz, float *work, int *lwork, int *iwork, int *liwork, int *info);
  void sstein_(int *n, float *d, float *e, int *m, float *w, int *iblock, int *isplit, float *z, int *ldz, float *work, int *iwork, int *ifail, int *info);
  void ssteqr_(char *compz, int *n, float *d, float *e, float *z, int *ldz, float *work, int *info);
  void ssterf_(int *n, float *d, float *e, int *info);
  void sstev_(char *jobz, int *n, float *d, float *e, float *z, int *ldz, float *work, int *info);
  void sstevd_(char *jobz, int *n, float *d, float *e, float *z, int *ldz, float *work, int *lwork, int *iwork, int *liwork, int *info);
  void sstevx_(char *jobz, char *range, int *n, float *d, float *e, float *vl, float *vu, int *il, int *iu, float *abstol, int *m, float *w, float *z, int *ldz, float *work, int *iwork, int *ifail, int *info);
  void ssycon_(char *uplo, int *n, float *a, int *lda, int *ipiv, float *anorm, float *rcond, float *work, int *iwork, int *info);
  void ssyev_(char *jobz, char *uplo, int *n, float *a, int *lda, float *w, float *work, int *lwork, int *info);
  void ssyevd_(char *jobz, char *uplo, int *n, float *a, int *lda, float *w, float *work, int *lwork, int *iwork, int *liwork, int *info);
  void ssyevx_(char *jobz, char *range, char *uplo, int *n, float *a, int *lda, float *vl, float *vu, int *il, int *iu, float *abstol, int *m, float *w, float *z, int *ldz, float *work, int *lwork, int *iwork, int *ifail, int *info);
  void ssygs2_(int *itype, char *uplo, int *n, float *a, int *lda, float *b, int *ldb, int *info);
  void ssygst_(int *itype, char *uplo, int *n, float *a, int *lda, float *b, int *ldb, int *info);
  void ssygv_(int *itype, char *jobz, char *uplo, int *n, float *a, int *lda, float *b, int *ldb, float *w, float *work, int *lwork, int *info);
  void ssyrfs_(char *uplo, int *n, int *nrhs, float *a, int *lda, float *af, int *ldaf, int *ipiv, float *b, int *ldb, float *x, int *ldx, float *ferr, float *berr, float *work, int *iwork, int *info);
  void ssysv_(char *uplo, int *n, int *nrhs, float *a, int *lda, int *ipiv, float *b, int *ldb, float *work, int *lwork, int *info);
  void ssysvx_(char *fact, char *uplo, int *n, int *nrhs, float *a, int *lda, float *af, int *ldaf, int *ipiv, float *b, int *ldb, float *x, int *ldx, float *rcond, float *ferr, float *berr, float *work, int *lwork, int *iwork, int *info);
  void ssytd2_(char *uplo, int *n, float *a, int *lda, float *d, float *e, float *tau, int *info);
  void ssytf2_(char *uplo, int *n, float *a, int *lda, int *ipiv, int *info);
  void ssytrd_(char *uplo, int *n, float *a, int *lda, float *d, float *e, float *tau, float *work, int *lwork, int *info);
  void ssytrf_(char *uplo, int *n, float *a, int *lda, int *ipiv, float *work, int *lwork, int *info);
  void ssytri_(char *uplo, int *n, float *a, int *lda, int *ipiv, float *work, int *info);
  void ssytrs_(char *uplo, int *n, int *nrhs, float *a, int *lda, int *ipiv, float *b, int *ldb, int *info);
  void stbcon_(char *norm, char *uplo, char *diag, int *n, int *kd, float *ab, int *ldab, float *rcond, float *work, int *iwork, int *info);
  void stbrfs_(char *uplo, char *trans, char *diag, int *n, int *kd, int *nrhs, float *ab, int *ldab, float *b, int *ldb, float *x, int *ldx, float *ferr, float *berr, float *work, int *iwork, int *info);
  void stbtrs_(char *uplo, char *trans, char *diag, int *n, int *kd, int *nrhs, float *ab, int *ldab, float *b, int *ldb, int *info);
  void stgevc_(char *side, char *howmny, int *select, int *n, float *a, int *lda, float *b, int *ldb, float *vl, int *ldvl, float *vr, int *ldvr, int *mm, int *m, float *work, int *info);
  void stgsja_(char *jobu, char *jobv, char *jobq, int *m, int *p, int *n, int *k, int *l, float *a, int *lda, float *b, int *ldb, float *tola, float *tolb, float *alpha, float *beta, float *u, int *ldu, float *v, int *ldv, float *q, int *ldq, float *work, int *ncycle, int *info);
  void stpcon_(char *norm, char *uplo, char *diag, int *n, float *ap, float *rcond, float *work, int *iwork, int *info);
  void stprfs_(char *uplo, char *trans, char *diag, int *n, int *nrhs, float *ap, float *b, int *ldb, float *x, int *ldx, float *ferr, float *berr, float *work, int *iwork, int *info);
  void stptri_(char *uplo, char *diag, int *n, float *ap, int *info);
  void stptrs_(char *uplo, char *trans, char *diag, int *n, int *nrhs, float *ap, float *b, int *ldb, int *info);
  void strcon_(char *norm, char *uplo, char *diag, int *n, float *a, int *lda, float *rcond, float *work, int *iwork, int *info);
  void strevc_(char *side, char *howmny, int *select, int *n, float *t, int *ldt, float *vl, int *ldvl, float *vr, int *ldvr, int *mm, int *m, float *work, int *info);
  void strexc_(char *compq, int *n, float *t, int *ldt, float *q, int *ldq, int *ifst, int *ilst, float *work, int *info);
  void strrfs_(char *uplo, char *trans, char *diag, int *n, int *nrhs, float *a, int *lda, float *b, int *ldb, float *x, int *ldx, float *ferr, float *berr, float *work, int *iwork, int *info);
  void strsen_(char *job, char *compq, int *select, int *n, float *t, int *ldt, float *q, int *ldq, float *wr, float *wi, int *m, float *s, float *sep, float *work, int *lwork, int *iwork, int *liwork, int *info);
  void strsna_(char *job, char *howmny, int *select, int *n, float *t, int *ldt, float *vl, int *ldvl, float *vr, int *ldvr, float *s, float *sep, int *mm, int *m, float *work, int *ldwork, int *iwork, int *info);
  void strsyl_(char *trana, char *tranb, int *isgn, int *m, int *n, float *a, int *lda, float *b, int *ldb, float *c, int *ldc, float *scale, int *info);
  void strti2_(char *uplo, char *diag, int *n, float *a, int *lda, int *info);
  void strtri_(char *uplo, char *diag, int *n, float *a, int *lda, int *info);
  void strtrs_(char *uplo, char *trans, char *diag, int *n, int *nrhs, float *a, int *lda, float *b, int *ldb, int *info);
  void stzrqf_(int *m, int *n, float *a, int *lda, float *tau, int *info);



  void dbdsqr_(char *uplo, int *n, int *ncvt, int *nru, int *ncc, double *d, double *e, double *vt, int *ldvt, double *u, int *ldu, double *c, int *ldc, double *work, int *info);
  void ddisna_(char *job, int *m, int *n, double *d, double *sep, int *info);
  void dgbbrd_(char *vect, int *m, int *n, int *ncc, int *kl, int *ku, double *ab, int *ldab, double *d, double *e, double *q, int *ldq, double *pt, int *ldpt, double *c, int *ldc, double *work, int *info);
  void dgbcon_(char *norm, int *n, int *kl, int *ku, double *ab, int *ldab, int *ipiv, double *anorm, double *rcond, double *work, int *iwork, int *info);
  void dgbequ_(int *m, int *n, int *kl, int *ku, double *ab, int *ldab, double *r, double *c, double *rowcnd, double *colcnd, double *amax, int *info);
  void dgbrfs_(char *trans, int *n, int *kl, int *ku, int *nrhs, double *ab, int *ldab, double *afb, int *ldafb, int *ipiv, double *b, int *ldb, double *x, int *ldx, double *ferr, double *berr, double *work, int *iwork, int *info);
  void dgbsv_(int *n, int *kl, int *ku, int *nrhs, double *ab, int *ldab, int *ipiv, double *b, int *ldb, int *info);
  void dgbsvx_(char *fact, char *trans, int *n, int *kl, int *ku, int *nrhs, double *ab, int *ldab, double *afb, int *ldafb, int *ipiv, char *equed, double *r, double *c, double *b, int *ldb, double *x, int *ldx, double *rcond, double *ferr, double *berr, double *work, int *iwork, int *info);
  void dgbtf2_(int *m, int *n, int *kl, int *ku, double *ab, int *ldab, int *ipiv, int *info);
  void dgbtrf_(int *m, int *n, int *kl, int *ku, double *ab, int *ldab, int *ipiv, int *info);
  void dgbtrs_(char *trans, int *n, int *kl, int *ku, int *nrhs, double *ab, int *ldab, int *ipiv, double *b, int *ldb, int *info);
  void dgebak_(char *job, char *side, int *n, int *ilo, int *ihi, double *scale, int *m, double *v, int *ldv, int *info);
  void dgebal_(char *job, int *n, double *a, int *lda, int *ilo, int *ihi, double *scale, int *info);
  void dgebd2_(int *m, int *n, double *a, int *lda, double *d, double *e, double *tauq, double *taup, double *work, int *info);
  void dgebrd_(int *m, int *n, double *a, int *lda, double *d, double *e, double *tauq, double *taup, double *work, int *lwork, int *info);
  void dgecon_(char *norm, int *n, double *a, int *lda, double *anorm, double *rcond, double *work, int *iwork, int *info);
  void dgeequ_(int *m, int *n, double *a, int *lda, double *r, double *c, double *rowcnd, double *colcnd, double *amax, int *info);
  void dgees_(char *jobvs, char *sort, int *select, int *n, double *a, int *lda, int *sdim, double *wr, double *wi, double *vs, int *ldvs, double *work, int *lwork, int *bwork, int *info);
  void dgeesx_(char *jobvs, char *sort, int *select, char *sense, int *n, double *a, int *lda, int *sdim, double *wr, double *wi, double *vs, int *ldvs, double *rconde, double *rcondv, double *work, int *lwork, int *iwork, int *liwork, int *bwork, int *info);
  void dgeev_(char *jobvl, char *jobvr, int *n, double *a, int *lda, double *wr, double *wi, double *vl, int *ldvl, double *vr, int *ldvr, double *work, int *lwork, int *info);
  void dgeevx_(char *balanc, char *jobvl, char *jobvr, char *sense, int *n, double *a, int *lda, double *wr, double *wi, double *vl, int *ldvl, double *vr, int *ldvr, int *ilo, int *ihi, double *scale, double *abnrm, double *rconde, double *rcondv, double *work, int *lwork, int *iwork, int *info);
  void dgegs_(char *jobvsl, char *jobvsr, int *n, double *a, int *lda, double *b, int *ldb, double *alphar, double *alphai, double *beta, double *vsl, int *ldvsl, double *vsr, int *ldvsr, double *work, int *lwork, int *info);
  void dgegv_(char *jobvl, char *jobvr, int *n, double *a, int *lda, double *b, int *ldb, double *alphar, double *alphai, double *beta, double *vl, int *ldvl, double *vr, int *ldvr, double *work, int *lwork, int *info);
  void dgehd2_(int *n, int *ilo, int *ihi, double *a, int *lda, double *tau, double *work, int *info);
  void dgehrd_(int *n, int *ilo, int *ihi, double *a, int *lda, double *tau, double *work, int *lwork, int *info);
  void dgelq2_(int *m, int *n, double *a, int *lda, double *tau, double *work, int *info);
  void dgelqf_(int *m, int *n, double *a, int *lda, double *tau, double *work, int *lwork, int *info);
  void dgels_(char *trans, int *m, int *n, int *nrhs, double *a, int *lda, double *b, int *ldb, double *work, int *lwork, int *info);
  void dgelss_(int *m, int *n, int *nrhs, double *a, int *lda, double *b, int *ldb, double *s, double *rcond, int *rank, double *work, int *lwork, int *info);
  void dgelsx_(int *m, int *n, int *nrhs, double *a, int *lda, double *b, int *ldb, int *jpvt, double *rcond, int *rank, double *work, int *info);
  void dgeql2_(int *m, int *n, double *a, int *lda, double *tau, double *work, int *info);
  void dgeqlf_(int *m, int *n, double *a, int *lda, double *tau, double *work, int *lwork, int *info);
  void dgeqpf_(int *m, int *n, double *a, int *lda, int *jpvt, double *tau, double *work, int *info);
  void dgeqr2_(int *m, int *n, double *a, int *lda, double *tau, double *work, int *info);
  void dgeqrf_(int *m, int *n, double *a, int *lda, double *tau, double *work, int *lwork, int *info);
  void dgerfs_(char *trans, int *n, int *nrhs, double *a, int *lda, double *af, int *ldaf, int *ipiv, double *b, int *ldb, double *x, int *ldx, double *ferr, double *berr, double *work, int *iwork, int *info);
  void dgerq2_(int *m, int *n, double *a, int *lda, double *tau, double *work, int *info);
  void dgerqf_(int *m, int *n, double *a, int *lda, double *tau, double *work, int *lwork, int *info);
  void dgesv_(int *n, int *nrhs, double *a, int *lda, int *ipiv, double *b, int *ldb, int *info);
  void dgesvd_(char *jobu, char *jobvt, int *m, int *n, double *a, int *lda, double *s, double *u, int *ldu, double *vt, int *ldvt, double *work, int *lwork, int *info);
  void dgesvx_(char *fact, char *trans, int *n, int *nrhs, double *a, int *lda, double *af, int *ldaf, int *ipiv, char *equed, double *r, double *c, double *b, int *ldb, double *x, int *ldx, double *rcond, double *ferr, double *berr, double *work, int *iwork, int *info);
  void dgetf2_(int *m, int *n, double *a, int *lda, int *ipiv, int *info);
  void dgetrf_(int *m, int *n, double *a, int *lda, int *ipiv, int *info);
  void dgetri_(int *n, double *a, int *lda, int *ipiv, double *work, int *lwork, int *info);
  void dgetrs_(char *trans, int *n, int *nrhs, double *a, int *lda, int *ipiv, double *b, int *ldb, int *info);
  void dggbak_(char *job, char *side, int *n, int *ilo, int *ihi, double *lscale, double *rscale, int *m, double *v, int *ldv, int *info);
  void dggbal_(char *job, int *n, double *a, int *lda, double *b, int *ldb, int *ilo, int *ihi, double *lscale, double *rscale, double *work, int *info);
  void dggglm_(int *n, int *m, int *p, double *a, int *lda, double *b, int *ldb, double *d, double *x, double *y, double *work, int *lwork, int *info);
  void dgghrd_(char *compq, char *compz, int *n, int *ilo, int *ihi, double *a, int *lda, double *b, int *ldb, double *q, int *ldq, double *z, int *ldz, int *info);
  void dgglse_(int *m, int *n, int *p, double *a, int *lda, double *b, int *ldb, double *c, double *d, double *x, double *work, int *lwork, int *info);
  void dggqrf_(int *n, int *m, int *p, double *a, int *lda, double *taua, double *b, int *ldb, double *taub, double *work, int *lwork, int *info);
  void dggrqf_(int *m, int *p, int *n, double *a, int *lda, double *taua, double *b, int *ldb, double *taub, double *work, int *lwork, int *info);
  void dggsvd_(char *jobu, char *jobv, char *jobq, int *m, int *n, int *p, int *k, int *l, double *a, int *lda, double *b, int *ldb, double *alpha, double *beta, double *u, int *ldu, double *v, int *ldv, double *q, int *ldq, double *work, int *iwork, int *info);
  void dggsvp_(char *jobu, char *jobv, char *jobq, int *m, int *p, int *n, double *a, int *lda, double *b, int *ldb, double *tola, double *tolb, int *k, int *l, double *u, int *ldu, double *v, int *ldv, double *q, int *ldq, int *iwork, double *tau, double *work, int *info);
  void dgtcon_(char *norm, int *n, double *dl, double *d, double *du, double *du2, int *ipiv, double *anorm, double *rcond, double *work, int *iwork, int *info);
  void dgtrfs_(char *trans, int *n, int *nrhs, double *dl, double *d, double *du, double *dlf, double *df, double *duf, double *du2, int *ipiv, double *b, int *ldb, double *x, int *ldx, double *ferr, double *berr, double *work, int *iwork, int *info);
  void dgtsv_(int *n, int *nrhs, double *dl, double *d, double *du, double *b, int *ldb, int *info);
  void dgtsvx_(char *fact, char *trans, int *n, int *nrhs, double *dl, double *d, double *du, double *dlf, double *df, double *duf, double *du2, int *ipiv, double *b, int *ldb, double *x, int *ldx, double *rcond, double *ferr, double *berr, double *work, int *iwork, int *info);
  void dgttrf_(int *n, double *dl, double *d, double *du, double *du2, int *ipiv, int *info);
  void dgttrs_(char *trans, int *n, int *nrhs, double *dl, double *d, double *du, double *du2, int *ipiv, double *b, int *ldb, int *info);
  void dhgeqz_(char *job, char *compq, char *compz, int *n, int *ilo, int *ihi, double *a, int *lda, double *b, int *ldb, double *alphar, double *alphai, double *beta, double *q, int *ldq, double *z, int *ldz, double *work, int *lwork, int *info);
  void dhsein_(char *side, char *eigsrc, char *initv, int *select, int *n, double *h, int *ldh, double *wr, double *wi, double *vl, int *ldvl, double *vr, int *ldvr, int *mm, int *m, double *work, int *ifaill, int *ifailr, int *info);
  void dhseqr_(char *job, char *compz, int *n, int *ilo, int *ihi, double *h, int *ldh, double *wr, double *wi, double *z, int *ldz, double *work, int *lwork, int *info);
  void dlaed0_(int *icompq, int *qsiz, int *n, double *d, double *e, double *q, int *ldq, double *qstore, int *ldqs, double *work, int *iwork, int *info);
  void dlaed1_(int *n, double *d, double *q, int *ldq, int *indxq, double *rho, int *cutpnt, double *work, int *iwork, int *info);
  void dlaed2_(int *k, int *n, double *d, double *q, int *ldq, int *indxq, double *rho, int *cutpnt, double *z, double *dlamda, double *q2, int *ldq2, int *indxc, double *w, int *indxp, int *indx, int *coltyp, int *info);
  void dlaed3_(int *k, int *kstart, int *kstop, int *n, double *d, double *q, int *ldq, double *rho, int *cutpnt, double *dlamda, double *q2, int *ldq2, int *indxc, int *ctot, double *w, double *s, int *lds, int *info);
  void dlaed4_(int *n, int *i, double *d, double *z, double *delta, double *rho, double *dlam, int *info);
  void dlaed5_(int *i, double *d, double *z, double *delta, double *rho, double *dlam);
  void dlaed6_(int *kniter, int *orgati, double *rho, double *d, double *z, double *finit, double *tau, int *info);
  void dlaed7_(int *icompq, int *n, int *qsiz, int *tlvls, int *curlvl, int *curpbm, double *d, double *q, int *ldq, int *indxq, double *rho, int *cutpnt, double *qstore, int *qptr, int *prmptr, int *perm, int *givptr, int *givcol, double *givnum, double *work, int *iwork, int *info);
  void dlaed8_(int *icompq, int *k, int *n, int *qsiz, double *d, double *q, int *ldq, int *indxq, double *rho, int *cutpnt, double *z, double *dlamda, double *q2, int *ldq2, double *w, int *perm, int *givptr, int *givcol, double *givnum, int *indxp, int *indx, int *info);
  void dlaed9_(int *k, int *kstart, int *kstop, int *n, double *d, double *q, int *ldq, double *rho, double *dlamda, double *w, double *s, int *lds, int *info);
  void dlaeda_(int *n, int *tlvls, int *curlvl, int *curpbm, int *prmptr, int *perm, int *givptr, int *givcol, double *givnum, double *q, int *qptr, double *z, double *ztemp, int *info);
  void dlagtf_(int *n, double *a, double *lambda, double *b, double *c, double *tol, double *d, int *in, int *info);
  void dlamrg_(int *n1, int *n2, double *a, int *dtrd1, int *dtrd2, int *index);
  void dlasq1_(int *n, double *d, double *e, double *work, int *info);
  void dlasq2_(int *m, double *q, double *e, double *qq, double *ee, double *eps, double *tol2, double *small2, double *sup, int *kend, int *info);
  void dlasq3_(int *n, double *q, double *e, double *qq, double *ee, double *sup, double *sigma, int *kend, int *off, int *iphase, int *iconv, double *eps, double *tol2, double *small2);
  void dlasq4_(int *n, double *q, double *e, double *tau, double *sup);
  void dlasrt_(char *id, int *n, double *d, int *info);
  void dlatzm_(char *side, int *m, int *n, double *v, int *incv, double *tau, double *c1, double *c2, int *ldc, double *work);
  void dopgtr_(char *uplo, int *n, double *ap, double *tau, double *q, int *ldq, double *work, int *info);
  void dopmtr_(char *side, char *uplo, char *trans, int *m, int *n, double *ap, double *tau, double *c, int *ldc, double *work, int *info);
  void dorg2l_(int *m, int *n, int *k, double *a, int *lda, double *tau, double *work, int *info);
  void dorg2r_(int *m, int *n, int *k, double *a, int *lda, double *tau, double *work, int *info);
  void dorgbr_(char *vect, int *m, int *n, int *k, double *a, int *lda, double *tau, double *work, int *lwork, int *info);
  void dorghr_(int *n, int *ilo, int *ihi, double *a, int *lda, double *tau, double *work, int *lwork, int *info);
  void dorgl2_(int *m, int *n, int *k, double *a, int *lda, double *tau, double *work, int *info);
  void dorglq_(int *m, int *n, int *k, double *a, int *lda, double *tau, double *work, int *lwork, int *info);
  void dorgql_(int *m, int *n, int *k, double *a, int *lda, double *tau, double *work, int *lwork, int *info);
  void dorgqr_(int *m, int *n, int *k, double *a, int *lda, double *tau, double *work, int *lwork, int *info);
  void dorgr2_(int *m, int *n, int *k, double *a, int *lda, double *tau, double *work, int *info);
  void dorgrq_(int *m, int *n, int *k, double *a, int *lda, double *tau, double *work, int *lwork, int *info);
  void dorgtr_(char *uplo, int *n, double *a, int *lda, double *tau, double *work, int *lwork, int *info);
  void dorm2l_(char *side, char *trans, int *m, int *n, int *k, double *a, int *lda, double *tau, double *c, int *ldc, double *work, int *info);
  void dorm2r_(char *side, char *trans, int *m, int *n, int *k, double *a, int *lda, double *tau, double *c, int *ldc, double *work, int *info);
  void dormbr_(char *vect, char *side, char *trans, int *m, int *n, int *k, double *a, int *lda, double *tau, double *c, int *ldc, double *work, int *lwork, int *info);
  void dormhr_(char *side, char *trans, int *m, int *n, int *ilo, int *ihi, double *a, int *lda, double *tau, double *c, int *ldc, double *work, int *lwork, int *info);
  void dorml2_(char *side, char *trans, int *m, int *n, int *k, double *a, int *lda, double *tau, double *c, int *ldc, double *work, int *info);
  void dormlq_(char *side, char *trans, int *m, int *n, int *k, double *a, int *lda, double *tau, double *c, int *ldc, double *work, int *lwork, int *info);
  void dormql_(char *side, char *trans, int *m, int *n, int *k, double *a, int *lda, double *tau, double *c, int *ldc, double *work, int *lwork, int *info);
  void dormqr_(char *side, char *trans, int *m, int *n, int *k, double *a, int *lda, double *tau, double *c, int *ldc, double *work, int *lwork, int *info);
  void dormr2_(char *side, char *trans, int *m, int *n, int *k, double *a, int *lda, double *tau, double *c, int *ldc, double *work, int *info);
  void dormrq_(char *side, char *trans, int *m, int *n, int *k, double *a, int *lda, double *tau, double *c, int *ldc, double *work, int *lwork, int *info);
  void dormtr_(char *side, char *uplo, char *trans, int *m, int *n, double *a, int *lda, double *tau, double *c, int *ldc, double *work, int *lwork, int *info);
  void dpbcon_(char *uplo, int *n, int *kd, double *ab, int *ldab, double *anorm, double *rcond, double *work, int *iwork, int *info);
  void dpbequ_(char *uplo, int *n, int *kd, double *ab, int *ldab, double *s, double *scond, double *amax, int *info);
  void dpbrfs_(char *uplo, int *n, int *kd, int *nrhs, double *ab, int *ldab, double *afb, int *ldafb, double *b, int *ldb, double *x, int *ldx, double *ferr, double *berr, double *work, int *iwork, int *info);
  void dpbstf_(char *uplo, int *n, int *kd, double *ab, int *ldab, int *info);
  void dpbsv_(char *uplo, int *n, int *kd, int *nrhs, double *ab, int *ldab, double *b, int *ldb, int *info);
  void dpbsvx_(char *fact, char *uplo, int *n, int *kd, int *nrhs, double *ab, int *ldab, double *afb, int *ldafb, char *equed, double *s, double *b, int *ldb, double *x, int *ldx, double *rcond, double *ferr, double *berr, double *work, int *iwork, int *info);
  void dpbtf2_(char *uplo, int *n, int *kd, double *ab, int *ldab, int *info);
  void dpbtrf_(char *uplo, int *n, int *kd, double *ab, int *ldab, int *info);
  void dpbtrs_(char *uplo, int *n, int *kd, int *nrhs, double *ab, int *ldab, double *b, int *ldb, int *info);
  void dpocon_(char *uplo, int *n, double *a, int *lda, double *anorm, double *rcond, double *work, int *iwork, int *info);
  void dpoequ_(int *n, double *a, int *lda, double *s, double *scond, double *amax, int *info);
  void dporfs_(char *uplo, int *n, int *nrhs, double *a, int *lda, double *af, int *ldaf, double *b, int *ldb, double *x, int *ldx, double *ferr, double *berr, double *work, int *iwork, int *info);
  void dposv_(char *uplo, int *n, int *nrhs, double *a, int *lda, double *b, int *ldb, int *info);
  void dposvx_(char *fact, char *uplo, int *n, int *nrhs, double *a, int *lda, double *af, int *ldaf, char *equed, double *s, double *b, int *ldb, double *x, int *ldx, double *rcond, double *ferr, double *berr, double *work, int *iwork, int *info);
  void dpotf2_(char *uplo, int *n, double *a, int *lda, int *info);
  void dpotrf_(char *uplo, int *n, double *a, int *lda, int *info);
  void dpotri_(char *uplo, int *n, double *a, int *lda, int *info);
  void dpotrs_(char *uplo, int *n, int *nrhs, double *a, int *lda, double *b, int *ldb, int *info);
  void dppcon_(char *uplo, int *n, double *ap, double *anorm, double *rcond, double *work, int *iwork, int *info);
  void dppequ_(char *uplo, int *n, double *ap, double *s, double *scond, double *amax, int *info);
  void dpprfs_(char *uplo, int *n, int *nrhs, double *ap, double *afp, double *b, int *ldb, double *x, int *ldx, double *ferr, double *berr, double *work, int *iwork, int *info);
  void dppsv_(char *uplo, int *n, int *nrhs, double *ap, double *b, int *ldb, int *info);
  void dppsvx_(char *fact, char *uplo, int *n, int *nrhs, double *ap, double *afp, char *equed, double *s, double *b, int *ldb, double *x, int *ldx, double *rcond, double *ferr, double *berr, double *work, int *iwork, int *info);
  void dpptrf_(char *uplo, int *n, double *ap, int *info);
  void dpptri_(char *uplo, int *n, double *ap, int *info);
  void dpptrs_(char *uplo, int *n, int *nrhs, double *ap, double *b, int *ldb, int *info);
  void dptcon_(int *n, double *d, double *e, double *anorm, double *rcond, double *work, int *info);
  void dpteqr_(char *compz, int *n, double *d, double *e, double *z, int *ldz, double *work, int *info);
  void dptrfs_(int *n, int *nrhs, double *d, double *e, double *df, double *ef, double *b, int *ldb, double *x, int *ldx, double *ferr, double *berr, double *work, int *info);
  void dptsv_(int *n, int *nrhs, double *d, double *e, double *b, int *ldb, int *info);
  void dptsvx_(char *fact, int *n, int *nrhs, double *d, double *e, double *df, double *ef, double *b, int *ldb, double *x, int *ldx, double *rcond, double *ferr, double *berr, double *work, int *info);
  void dpttrf_(int *n, double *d, double *e, int *info);
  void dpttrs_(int *n, int *nrhs, double *d, double *e, double *b, int *ldb, int *info);
  void dsbev_(char *jobz, char *uplo, int *n, int *kd, double *ab, int *ldab, double *w, double *z, int *ldz, double *work, int *info);
  void dsbevd_(char *jobz, char *uplo, int *n, int *kd, double *ab, int *ldab, double *w, double *z, int *ldz, double *work, int *lwork, int *iwork, int *liwork, int *info);
  void dsbevx_(char *jobz, char *range, char *uplo, int *n, int *kd, double *ab, int *ldab, double *q, int *ldq, double *vl, double *vu, int *il, int *iu, double *abstol, int *m, double *w, double *z, int *ldz, double *work, int *iwork, int *ifail, int *info);
  void dsbgst_(char *vect, char *uplo, int *n, int *ka, int *kb, double *ab, int *ldab, double *bb, int *ldbb, double *x, int *ldx, double *work, int *info);
  void dsbgv_(char *jobz, char *uplo, int *n, int *ka, int *kb, double *ab, int *ldab, double *bb, int *ldbb, double *w, double *z, int *ldz, double *work, int *info);
  void dsbtrd_(char *vect, char *uplo, int *n, int *kd, double *ab, int *ldab, double *d, double *e, double *q, int *ldq, double *work, int *info);
  void dspcon_(char *uplo, int *n, double *ap, int *ipiv, double *anorm, double *rcond, double *work, int *iwork, int *info);
  void dspev_(char *jobz, char *uplo, int *n, double *ap, double *w, double *z, int *ldz, double *work, int *info);
  void dspevd_(char *jobz, char *uplo, int *n, double *ap, double *w, double *z, int *ldz, double *work, int *lwork, int *iwork, int *liwork, int *info);
  void dspevx_(char *jobz, char *range, char *uplo, int *n, double *ap, double *vl, double *vu, int *il, int *iu, double *abstol, int *m, double *w, double *z, int *ldz, double *work, int *iwork, int *ifail, int *info);
  void dspgst_(int *itype, char *uplo, int *n, double *ap, double *bp, int *info);
  void dspgv_(int *itype, char *jobz, char *uplo, int *n, double *ap, double *bp, double *w, double *z, int *ldz, double *work, int *info);
  void dsprfs_(char *uplo, int *n, int *nrhs, double *ap, double *afp, int *ipiv, double *b, int *ldb, double *x, int *ldx, double *ferr, double *berr, double *work, int *iwork, int *info);
  void dspsv_(char *uplo, int *n, int *nrhs, double *ap, int *ipiv, double *b, int *ldb, int *info);
  void dspsvx_(char *fact, char *uplo, int *n, int *nrhs, double *ap, double *afp, int *ipiv, double *b, int *ldb, double *x, int *ldx, double *rcond, double *ferr, double *berr, double *work, int *iwork, int *info);
  void dsptrd_(char *uplo, int *n, double *ap, double *d, double *e, double *tau, int *info);
  void dsptrf_(char *uplo, int *n, double *ap, int *ipiv, int *info);
  void dsptri_(char *uplo, int *n, double *ap, int *ipiv, double *work, int *info);
  void dsptrs_(char *uplo, int *n, int *nrhs, double *ap, int *ipiv, double *b, int *ldb, int *info);
  void dstebz_(char *range, char *order, int *n, double *vl, double *vu, int *il, int *iu, double *abstol, double *d, double *e, int *m, int *nsplit, double *w, int *iblock, int *isplit, double *work, int *iwork, int *info);
  void dstedc_(char *compz, int *n, double *d, double *e, double *z, int *ldz, double *work, int *lwork, int *iwork, int *liwork, int *info);
  void dstein_(int *n, double *d, double *e, int *m, double *w, int *iblock, int *isplit, double *z, int *ldz, double *work, int *iwork, int *ifail, int *info);
  void dsteqr_(char *compz, int *n, double *d, double *e, double *z, int *ldz, double *work, int *info);
  void dsterf_(int *n, double *d, double *e, int *info);
  void dstev_(char *jobz, int *n, double *d, double *e, double *z, int *ldz, double *work, int *info);
  void dstevd_(char *jobz, int *n, double *d, double *e, double *z, int *ldz, double *work, int *lwork, int *iwork, int *liwork, int *info);
  void dstevx_(char *jobz, char *range, int *n, double *d, double *e, double *vl, double *vu, int *il, int *iu, double *abstol, int *m, double *w, double *z, int *ldz, double *work, int *iwork, int *ifail, int *info);
  void dsycon_(char *uplo, int *n, double *a, int *lda, int *ipiv, double *anorm, double *rcond, double *work, int *iwork, int *info);
  void dsyev_(char *jobz, char *uplo, int *n, double *a, int *lda, double *w, double *work, int *lwork, int *info);
  void dsyevd_(char *jobz, char *uplo, int *n, double *a, int *lda, double *w, double *work, int *lwork, int *iwork, int *liwork, int *info);
  void dsyevx_(char *jobz, char *range, char *uplo, int *n, double *a, int *lda, double *vl, double *vu, int *il, int *iu, double *abstol, int *m, double *w, double *z, int *ldz, double *work, int *lwork, int *iwork, int *ifail, int *info);
  void dsygs2_(int *itype, char *uplo, int *n, double *a, int *lda, double *b, int *ldb, int *info);
  void dsygst_(int *itype, char *uplo, int *n, double *a, int *lda, double *b, int *ldb, int *info);
  void dsygv_(int *itype, char *jobz, char *uplo, int *n, double *a, int *lda, double *b, int *ldb, double *w, double *work, int *lwork, int *info);
  void dsyrfs_(char *uplo, int *n, int *nrhs, double *a, int *lda, double *af, int *ldaf, int *ipiv, double *b, int *ldb, double *x, int *ldx, double *ferr, double *berr, double *work, int *iwork, int *info);
  void dsysv_(char *uplo, int *n, int *nrhs, double *a, int *lda, int *ipiv, double *b, int *ldb, double *work, int *lwork, int *info);
  void dsysvx_(char *fact, char *uplo, int *n, int *nrhs, double *a, int *lda, double *af, int *ldaf, int *ipiv, double *b, int *ldb, double *x, int *ldx, double *rcond, double *ferr, double *berr, double *work, int *lwork, int *iwork, int *info);
  void dsytd2_(char *uplo, int *n, double *a, int *lda, double *d, double *e, double *tau, int *info);
  void dsytf2_(char *uplo, int *n, double *a, int *lda, int *ipiv, int *info);
  void dsytrd_(char *uplo, int *n, double *a, int *lda, double *d, double *e, double *tau, double *work, int *lwork, int *info);
  void dsytrf_(char *uplo, int *n, double *a, int *lda, int *ipiv, double *work, int *lwork, int *info);
  void dsytri_(char *uplo, int *n, double *a, int *lda, int *ipiv, double *work, int *info);
  void dsytrs_(char *uplo, int *n, int *nrhs, double *a, int *lda, int *ipiv, double *b, int *ldb, int *info);
  void dtbcon_(char *norm, char *uplo, char *diag, int *n, int *kd, double *ab, int *ldab, double *rcond, double *work, int *iwork, int *info);
  void dtbrfs_(char *uplo, char *trans, char *diag, int *n, int *kd, int *nrhs, double *ab, int *ldab, double *b, int *ldb, double *x, int *ldx, double *ferr, double *berr, double *work, int *iwork, int *info);
  void dtbtrs_(char *uplo, char *trans, char *diag, int *n, int *kd, int *nrhs, double *ab, int *ldab, double *b, int *ldb, int *info);
  void dtgevc_(char *side, char *howmny, int *select, int *n, double *a, int *lda, double *b, int *ldb, double *vl, int *ldvl, double *vr, int *ldvr, int *mm, int *m, double *work, int *info);
  void dtgsja_(char *jobu, char *jobv, char *jobq, int *m, int *p, int *n, int *k, int *l, double *a, int *lda, double *b, int *ldb, double *tola, double *tolb, double *alpha, double *beta, double *u, int *ldu, double *v, int *ldv, double *q, int *ldq, double *work, int *ncycle, int *info);
  void dtpcon_(char *norm, char *uplo, char *diag, int *n, double *ap, double *rcond, double *work, int *iwork, int *info);
  void dtprfs_(char *uplo, char *trans, char *diag, int *n, int *nrhs, double *ap, double *b, int *ldb, double *x, int *ldx, double *ferr, double *berr, double *work, int *iwork, int *info);
  void dtptri_(char *uplo, char *diag, int *n, double *ap, int *info);
  void dtptrs_(char *uplo, char *trans, char *diag, int *n, int *nrhs, double *ap, double *b, int *ldb, int *info);
  void dtrcon_(char *norm, char *uplo, char *diag, int *n, double *a, int *lda, double *rcond, double *work, int *iwork, int *info);
  void dtrevc_(char *side, char *howmny, int *select, int *n, double *t, int *ldt, double *vl, int *ldvl, double *vr, int *ldvr, int *mm, int *m, double *work, int *info);
  void dtrexc_(char *compq, int *n, double *t, int *ldt, double *q, int *ldq, int *ifst, int *ilst, double *work, int *info);
  void dtrrfs_(char *uplo, char *trans, char *diag, int *n, int *nrhs, double *a, int *lda, double *b, int *ldb, double *x, int *ldx, double *ferr, double *berr, double *work, int *iwork, int *info);
  void dtrsen_(char *job, char *compq, int *select, int *n, double *t, int *ldt, double *q, int *ldq, double *wr, double *wi, int *m, double *s, double *sep, double *work, int *lwork, int *iwork, int *liwork, int *info);
  void dtrsna_(char *job, char *howmny, int *select, int *n, double *t, int *ldt, double *vl, int *ldvl, double *vr, int *ldvr, double *s, double *sep, int *mm, int *m, double *work, int *ldwork, int *iwork, int *info);
  void dtrsyl_(char *trana, char *tranb, int *isgn, int *m, int *n, double *a, int *lda, double *b, int *ldb, double *c, int *ldc, double *scale, int *info);
  void dtrti2_(char *uplo, char *diag, int *n, double *a, int *lda, int *info);
  void dtrtri_(char *uplo, char *diag, int *n, double *a, int *lda, int *info);
  void dtrtrs_(char *uplo, char *trans, char *diag, int *n, int *nrhs, double *a, int *lda, double *b, int *ldb, int *info);
  void dtzrqf_(int *m, int *n, double *a, int *lda, double *tau, int *info);
  void zbdsqr_(char *uplo, int *n, int *ncvt, int *nru, int *ncc, double *d, double *e, cpx16 *vt, int *ldvt, cpx16 *u, int *ldu, cpx16 *c, int *ldc, double *rwork, int *info);
  void zdrot_(int *n, cpx16 *cx, int *incx, cpx16 *cy, int *incy, double *c, double *s);
  void zgbbrd_(char *vect, int *m, int *n, int *ncc, int *kl, int *ku, cpx16 *ab, int *ldab, double *d, double *e, cpx16 *q, int *ldq, cpx16 *pt, int *ldpt, cpx16 *c, int *ldc, cpx16 *work, double *rwork, int *info);
  void zgbcon_(char *norm, int *n, int *kl, int *ku, cpx16 *ab, int *ldab, int *ipiv, double *anorm, double *rcond, cpx16 *work, double *rwork, int *info);
  void zgbequ_(int *m, int *n, int *kl, int *ku, cpx16 *ab, int *ldab, double *r, double *c, double *rowcnd, double *colcnd, double *amax, int *info);
  void zgbrfs_(char *trans, int *n, int *kl, int *ku, int *nrhs, cpx16 *ab, int *ldab, cpx16 *afb, int *ldafb, int *ipiv, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
void zgbsv_(int *n, int *kl, int *ku, int *nrhs, cpx16 *ab, int *ldab, int *ipiv, cpx16 *b, int *ldb, int *info);
  void zgbsvx_(char *fact, char *trans, int *n, int *kl, int *ku, int *nrhs, cpx16 *ab, int *ldab, cpx16 *afb, int *ldafb, int *ipiv, char *equed, double *r, double *c, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *rcond, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
  void zgbtf2_(int *m, int *n, int *kl, int *ku, cpx16 *ab, int *ldab, int *ipiv, int *info);
  void zgbtrf_(int *m, int *n, int *kl, int *ku, cpx16 *ab, int *ldab, int *ipiv, int *info);
  void zgbtrs_(char *trans, int *n, int *kl, int *ku, int *nrhs, cpx16 *ab, int *ldab, int *ipiv, cpx16 *b, int *ldb, int *info);
  void zgebak_(char *job, char *side, int *n, int *ilo, int *ihi, double *scale, int *m, cpx16 *v, int *ldv, int *info);
  void zgebal_(char *job, int *n, cpx16 *a, int *lda, int *ilo, int *ihi, double *scale, int *info);
  void zgebd2_(int *m, int *n, cpx16 *a, int *lda, double *d, double *e, cpx16 *tauq, cpx16 *taup, cpx16 *work, int *info);
  void zgebrd_(int *m, int *n, cpx16 *a, int *lda, double *d, double *e, cpx16 *tauq, cpx16 *taup, cpx16 *work, int *lwork, int *info);
  void zgecon_(char *norm, int *n, cpx16 *a, int *lda, double *anorm, double *rcond, cpx16 *work, double *rwork, int *info);
  void zgeequ_(int *m, int *n, cpx16 *a, int *lda, double *r, double *c, double *rowcnd, double *colcnd, double *amax, int *info);
  void zgees_(char *jobvs, char *sort, int *select, int *n, cpx16 *a, int *lda, int *sdim, cpx16 *w, cpx16 *vs, int *ldvs, cpx16 *work, int *lwork, double *rwork, int *bwork, int *info);
  void zgeesx_(char *jobvs, char *sort, int *select, char *sense, int *n, cpx16 *a, int *lda, int *sdim, cpx16 *w, cpx16 *vs, int *ldvs, double *rconde, double *rcondv, cpx16 *work, int *lwork, double *rwork, int *bwork, int *info);
  void zgeev_(char *jobvl, char *jobvr, int *n, cpx16 *a, int *lda, cpx16 *w, cpx16 *vl, int *ldvl, cpx16 *vr, int *ldvr, cpx16 *work, int *lwork, double *rwork, int *info);
  void zgeevx_(char *balanc, char *jobvl, char *jobvr, char *sense, int *n, cpx16 *a, int *lda, cpx16 *w, cpx16 *vl, int *ldvl, cpx16 *vr, int *ldvr, int *ilo, int *ihi, double *scale, double *abnrm, double *rconde, double *rcondv, cpx16 *work, int *lwork, double *rwork, int *info);
  void zgegs_(char *jobvsl, char *jobvsr, int *n, cpx16 *a, int *lda, cpx16 *b, int *ldb, cpx16 *alpha, cpx16 *beta, cpx16 *vsl, int *ldvsl, cpx16 *vsr, int *ldvsr, cpx16 *work, int *lwork, double *rwork, int *info);
  void zgegv_(char *jobvl, char *jobvr, int *n, cpx16 *a, int *lda, cpx16 *b, int *ldb, cpx16 *alpha, cpx16 *beta, cpx16 *vl, int *ldvl, cpx16 *vr, int *ldvr, cpx16 *work, int *lwork, double *rwork, int *info);
  void zgehd2_(int *n, int *ilo, int *ihi, cpx16 *a, int *lda, cpx16 *tau, cpx16 *work, int *info);
  void zgehrd_(int *n, int *ilo, int *ihi, cpx16 *a, int *lda, cpx16 *tau, cpx16 *work, int *lwork, int *info);
  void zgelq2_(int *m, int *n, cpx16 *a, int *lda, cpx16 *tau, cpx16 *work, int *info);
  void zgelqf_(int *m, int *n, cpx16 *a, int *lda, cpx16 *tau, cpx16 *work, int *lwork, int *info);
  void zgels_(char *trans, int *m, int *n, int *nrhs, cpx16 *a, int *lda, cpx16 *b, int *ldb, cpx16 *work, int *lwork, int *info);
  void zgelss_(int *m, int *n, int *nrhs, cpx16 *a, int *lda, cpx16 *b, int *ldb, double *s, double *rcond, int *rank, cpx16 *work, int *lwork, double *rwork, int *info);
  void zgelsx_(int *m, int *n, int *nrhs, cpx16 *a, int *lda, cpx16 *b, int *ldb, int *jpvt, double *rcond, int *rank, cpx16 *work, double *rwork, int *info);
  void zgeql2_(int *m, int *n, cpx16 *a, int *lda, cpx16 *tau, cpx16 *work, int *info);
  void zgeqlf_(int *m, int *n, cpx16 *a, int *lda, cpx16 *tau, cpx16 *work, int *lwork, int *info);
  void zgeqr2_(int *m, int *n, cpx16 *a, int *lda, cpx16 *tau, cpx16 *work, int *info);
  void zgeqrf_(int *m, int *n, cpx16 *a, int *lda, cpx16 *tau, cpx16 *work, int *lwork, int *info);
  void zgerfs_(char *trans, int *n, int *nrhs, cpx16 *a, int *lda, cpx16 *af, int *ldaf, int *ipiv, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
  void zgerq2_(int *m, int *n, cpx16 *a, int *lda, cpx16 *tau, cpx16 *work, int *info);
  void zgerqf_(int *m, int *n, cpx16 *a, int *lda, cpx16 *tau, cpx16 *work, int *lwork, int *info);
  void zgesv_(int *n, int *nrhs, cpx16 *a, int *lda, int *ipiv, cpx16 *b, int *ldb, int *info);
  void zgesvd_(char *jobu, char *jobvt, int *m, int *n, cpx16 *a, int *lda, double *s, cpx16 *u, int *ldu, cpx16 *vt, int *ldvt, cpx16 *work, int *lwork, double *rwork, int *info);
  void zgesvx_(char *fact, char *trans, int *n, int *nrhs, cpx16 *a, int *lda, cpx16 *af, int *ldaf, int *ipiv, char *equed, double *r, double *c, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *rcond, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
  void zgetf2_(int *m, int *n, cpx16 *a, int *lda, int *ipiv, int *info);
  void zgetrf_(int *m, int *n, cpx16 *a, int *lda, int *ipiv, int *info);
  void zgetri_(int *n, cpx16 *a, int *lda, int *ipiv, cpx16 *work, int *lwork, int *info);
  void zgetrs_(char *trans, int *n, int *nrhs, cpx16 *a, int *lda, int *ipiv, cpx16 *b, int *ldb, int *info);
  void zggbak_(char *job, char *side, int *n, int *ilo, int *ihi, double *lscale, double *rscale, int *m, cpx16 *v, int *ldv, int *info);
  void zggbal_(char *job, int *n, cpx16 *a, int *lda, cpx16 *b, int *ldb, int *ilo, int *ihi, double *lscale, double *rscale, double *work, int *info);
  void zggglm_(int *n, int *m, int *p, cpx16 *a, int *lda, cpx16 *b, int *ldb, cpx16 *d, cpx16 *x, cpx16 *y, cpx16 *work, int *lwork, int *info);
  void zgghrd_(char *compq, char *compz, int *n, int *ilo, int *ihi, cpx16 *a, int *lda, cpx16 *b, int *ldb, cpx16 *q, int *ldq, cpx16 *z, int *ldz, int *info);
  void zgglse_(int *m, int *n, int *p, cpx16 *a, int *lda, cpx16 *b, int *ldb, cpx16 *c, cpx16 *d, cpx16 *x, cpx16 *work, int *lwork, int *info);
  void zggqrf_(int *n, int *m, int *p, cpx16 *a, int *lda, cpx16 *taua, cpx16 *b, int *ldb, cpx16 *taub, cpx16 *work, int *lwork, int *info);
  void zggrqf_(int *m, int *p, int *n, cpx16 *a, int *lda, cpx16 *taua, cpx16 *b, int *ldb, cpx16 *taub, cpx16 *work, int *lwork, int *info);
  void zggsvd_(char *jobu, char *jobv, char *jobq, int *m, int *n, int *p, int *k, int *l, cpx16 *a, int *lda, cpx16 *b, int *ldb, double *alpha, double *beta, cpx16 *u, int *ldu, cpx16 *v, int *ldv, cpx16 *q, int *ldq, cpx16 *work, double *rwork, int *iwork, int *info);
  void zggsvp_(char *jobu, char *jobv, char *jobq, int *m, int *p, int *n, cpx16 *a, int *lda, cpx16 *b, int *ldb, double *tola, double *tolb, int *k, int *l, cpx16 *u, int *ldu, cpx16 *v, int *ldv, cpx16 *q, int *ldq, int *iwork, double *rwork, cpx16 *tau, cpx16 *work, int *info);
  void zgtcon_(char *norm, int *n, cpx16 *dl, cpx16 *d, cpx16 *du, cpx16 *du2, int *ipiv, double *anorm, double *rcond, cpx16 *work, int *info);
  void zgtrfs_(char *trans, int *n, int *nrhs, cpx16 *dl, cpx16 *d, cpx16 *du, cpx16 *dlf, cpx16 *df, cpx16 *duf, cpx16 *du2, int *ipiv, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
  void zgtsv_(int *n, int *nrhs, cpx16 *dl, cpx16 *d, cpx16 *du, cpx16 *b, int *ldb, int *info);
  void zgtsvx_(char *fact, char *trans, int *n, int *nrhs, cpx16 *dl, cpx16 *d, cpx16 *du, cpx16 *dlf, cpx16 *df, cpx16 *duf, cpx16 *du2, int *ipiv, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *rcond, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
  void zgttrf_(int *n, cpx16 *dl, cpx16 *d, cpx16 *du, cpx16 *du2, int *ipiv, int *info);
  void zgttrs_(char *trans, int *n, int *nrhs, cpx16 *dl, cpx16 *d, cpx16 *du, cpx16 *du2, int *ipiv, cpx16 *b, int *ldb, int *info);
  void zhbev_(char *jobz, char *uplo, int *n, int *kd, cpx16 *ab, int *ldab, double *w, cpx16 *z, int *ldz, cpx16 *work, double *rwork, int *info);
  void zhbevd_(char *jobz, char *uplo, int *n, int *kd, cpx16 *ab, int *ldab, double *w, cpx16 *z, int *ldz, cpx16 *work, int *lwork, double *rwork, int *lrwork, int *iwork, int *liwork, int *info);
  void zhbevx_(char *jobz, char *range, char *uplo, int *n, int *kd, cpx16 *ab, int *ldab, cpx16 *q, int *ldq, double *vl, double *vu, int *il, int *iu, double *abstol, int *m, double *w, cpx16 *z, int *ldz, cpx16 *work, double *rwork, int *iwork, int *ifail, int *info);
  void zhbgst_(char *vect, char *uplo, int *n, int *ka, int *kb, cpx16 *ab, int *ldab, cpx16 *bb, int *ldbb, cpx16 *x, int *ldx, cpx16 *work, double *rwork, int *info);
  void zhbgv_(char *jobz, char *uplo, int *n, int *ka, int *kb, cpx16 *ab, int *ldab, cpx16 *bb, int *ldbb, double *w, cpx16 *z, int *ldz, cpx16 *work, double *rwork, int *info);
  void zhbtrd_(char *vect, char *uplo, int *n, int *kd, cpx16 *ab, int *ldab, double *d, double *e, cpx16 *q, int *ldq, cpx16 *work, int *info);
  void zhecon_(char *uplo, int *n, cpx16 *a, int *lda, int *ipiv, double *anorm, double *rcond, cpx16 *work, int *info);
  void zheev_(char *jobz, char *uplo, int *n, cpx16 *a, int *lda, double *w, cpx16 *work, int *lwork, double *rwork, int *info);
  void zheevd_(char *jobz, char *uplo, int *n, cpx16 *a, int *lda, double *w, cpx16 *work, int *lwork, double *rwork, int *lrwork, int *iwork, int *liwork, int *info);
  void zheevx_(char *jobz, char *range, char *uplo, int *n, cpx16 *a, int *lda, double *vl, double *vu, int *il, int *iu, double *abstol, int *m, double *w, cpx16 *z, int *ldz, cpx16 *work, int *lwork, double *rwork, int *iwork, int *ifail, int *info);
  void zhegs2_(int *itype, char *uplo, int *n, cpx16 *a, int *lda, cpx16 *b, int *ldb, int *info);
  void zhegst_(int *itype, char *uplo, int *n, cpx16 *a, int *lda, cpx16 *b, int *ldb, int *info);
  void zhegv_(int *itype, char *jobz, char *uplo, int *n, cpx16 *a, int *lda, cpx16 *b, int *ldb, double *w, cpx16 *work, int *lwork, double *rwork, int *info);
  void zherfs_(char *uplo, int *n, int *nrhs, cpx16 *a, int *lda, cpx16 *af, int *ldaf, int *ipiv, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
  void zhesv_(char *uplo, int *n, int *nrhs, cpx16 *a, int *lda, int *ipiv, cpx16 *b, int *ldb, cpx16 *work, int *lwork, int *info);
  void zhesvx_(char *fact, char *uplo, int *n, int *nrhs, cpx16 *a, int *lda, cpx16 *af, int *ldaf, int *ipiv, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *rcond, double *ferr, double *berr, cpx16 *work, int *lwork, double *rwork, int *info);
  void zhetd2_(char *uplo, int *n, cpx16 *a, int *lda, double *d, double *e, cpx16 *tau, int *info);
  void zhetf2_(char *uplo, int *n, cpx16 *a, int *lda, int *ipiv, int *info);
  void zhetrd_(char *uplo, int *n, cpx16 *a, int *lda, double *d, double *e, cpx16 *tau, cpx16 *work, int *lwork, int *info);
  void zhetrf_(char *uplo, int *n, cpx16 *a, int *lda, int *ipiv, cpx16 *work, int *lwork, int *info);
  void zhetri_(char *uplo, int *n, cpx16 *a, int *lda, int *ipiv, cpx16 *work, int *info);
  void zhetrs_(char *uplo, int *n, int *nrhs, cpx16 *a, int *lda, int *ipiv, cpx16 *b, int *ldb, int *info);
  void zhgeqz_(char *job, char *compq, char *compz, int *n, int *ilo, int *ihi, cpx16 *a, int *lda, cpx16 *b, int *ldb, cpx16 *alpha, cpx16 *beta, cpx16 *q, int *ldq, cpx16 *z, int *ldz, cpx16 *work, int *lwork, double *rwork, int *info);
  void zhpcon_(char *uplo, int *n, cpx16 *ap, int *ipiv, double *anorm, double *rcond, cpx16 *work, int *info);
  void zhpev_(char *jobz, char *uplo, int *n, cpx16 *ap, double *w, cpx16 *z, int *ldz, cpx16 *work, double *rwork, int *info);
  void zhpevd_(char *jobz, char *uplo, int *n, cpx16 *ap, double *w, cpx16 *z, int *ldz, cpx16 *work, int *lwork, double *rwork, int *lrwork, int *iwork, int *liwork, int *info);
  void zhpevx_(char *jobz, char *range, char *uplo, int *n, cpx16 *ap, double *vl, double *vu, int *il, int *iu, double *abstol, int *m, double *w, cpx16 *z, int *ldz, cpx16 *work, double *rwork, int *iwork, int *ifail, int *info);
  void zhpgst_(int *itype, char *uplo, int *n, cpx16 *ap, cpx16 *bp, int *info);
  void zhpgv_(int *itype, char *jobz, char *uplo, int *n, cpx16 *ap, cpx16 *bp, double *w, cpx16 *z, int *ldz, cpx16 *work, double *rwork, int *info);
  void zhprfs_(char *uplo, int *n, int *nrhs, cpx16 *ap, cpx16 *afp, int *ipiv, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
  void zhpsv_(char *uplo, int *n, int *nrhs, cpx16 *ap, int *ipiv, cpx16 *b, int *ldb, int *info);
  void zhpsvx_(char *fact, char *uplo, int *n, int *nrhs, cpx16 *ap, cpx16 *afp, int *ipiv, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *rcond, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
  void zhptrd_(char *uplo, int *n, cpx16 *ap, double *d, double *e, cpx16 *tau, int *info);
  void zhptrf_(char *uplo, int *n, cpx16 *ap, int *ipiv, int *info);
  void zhptri_(char *uplo, int *n, cpx16 *ap, int *ipiv, cpx16 *work, int *info);
  void zhptrs_(char *uplo, int *n, int *nrhs, cpx16 *ap, int *ipiv, cpx16 *b, int *ldb, int *info);
  void zhsein_(char *side, char *eigsrc, char *initv, int *select, int *n, cpx16 *h, int *ldh, cpx16 *w, cpx16 *vl, int *ldvl, cpx16 *vr, int *ldvr, int *mm, int *m, cpx16 *work, double *rwork, int *ifaill, int *ifailr, int *info);
  void zhseqr_(char *job, char *compz, int *n, int *ilo, int *ihi, cpx16 *h, int *ldh, cpx16 *w, cpx16 *z, int *ldz, cpx16 *work, int *lwork, int *info);
  void zlaed0_(int *qsiz, int *n, double *d, double *e, cpx16 *q, int *ldq, cpx16 *qstore, int *ldqs, double *rwork, int *iwork, int *info);
  void zlaed7_(int *n, int *cutpnt, int *qsiz, int *tlvls, int *curlvl, int *curpbm, double *d, cpx16 *q, int *ldq, double *rho, int *indxq, double *qstore, int *qptr, int *prmptr, int *perm, int *givptr, int *givcol, double *givnum, cpx16 *work, double *rwork, int *iwork, int *info);
  void zlaed8_(int *k, int *n, int *qsiz, cpx16 *q, int *ldq, double *d, double *rho, int *cutpnt, double *z, double *dlamda, cpx16 *q2, int *ldq2, double *w, int *indxp, int *indx, int *indxq, int *perm, int *givptr, int *givcol, double *givnum, int *info);
  void zlatzm_(char *side, int *m, int *n, cpx16 *v, int *incv, cpx16 *tau, cpx16 *c1, cpx16 *c2, int *ldc, cpx16 *work);
  void zpbcon_(char *uplo, int *n, int *kd, cpx16 *ab, int *ldab, double *anorm, double *rcond, cpx16 *work, double *rwork, int *info);
  void zpbequ_(char *uplo, int *n, int *kd, cpx16 *ab, int *ldab, double *s, double *scond, double *amax, int *info);
  void zpbrfs_(char *uplo, int *n, int *kd, int *nrhs, cpx16 *ab, int *ldab, cpx16 *afb, int *ldafb, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
  void zpbstf_(char *uplo, int *n, int *kd, cpx16 *ab, int *ldab, int *info);
  void zpbsv_(char *uplo, int *n, int *kd, int *nrhs, cpx16 *ab, int *ldab, cpx16 *b, int *ldb, int *info);
  void zpbsvx_(char *fact, char *uplo, int *n, int *kd, int *nrhs, cpx16 *ab, int *ldab, cpx16 *afb, int *ldafb, char *equed, double *s, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *rcond, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
  void zpbtf2_(char *uplo, int *n, int *kd, cpx16 *ab, int *ldab, int *info);
  void zpbtrf_(char *uplo, int *n, int *kd, cpx16 *ab, int *ldab, int *info);
  void zpbtrs_(char *uplo, int *n, int *kd, int *nrhs, cpx16 *ab, int *ldab, cpx16 *b, int *ldb, int *info);
  void zpocon_(char *uplo, int *n, cpx16 *a, int *lda, double *anorm, double *rcond, cpx16 *work, double *rwork, int *info);
  void zpoequ_(int *n, cpx16 *a, int *lda, double *s, double *scond, double *amax, int *info);
  void zporfs_(char *uplo, int *n, int *nrhs, cpx16 *a, int *lda, cpx16 *af, int *ldaf, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
  void zposv_(char *uplo, int *n, int *nrhs, cpx16 *a, int *lda, cpx16 *b, int *ldb, int *info);
  void zposvx_(char *fact, char *uplo, int *n, int *nrhs, cpx16 *a, int *lda, cpx16 *af, int *ldaf, char *equed, double *s, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *rcond, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
  void zpotf2_(char *uplo, int *n, cpx16 *a, int *lda, int *info);
  void zpotrf_(char *uplo, int *n, cpx16 *a, int *lda, int *info);
  void zpotri_(char *uplo, int *n, cpx16 *a, int *lda, int *info);
  void zpotrs_(char *uplo, int *n, int *nrhs, cpx16 *a, int *lda, cpx16 *b, int *ldb, int *info);
  void zppcon_(char *uplo, int *n, cpx16 *ap, double *anorm, double *rcond, cpx16 *work, double *rwork, int *info);
  void zppequ_(char *uplo, int *n, cpx16 *ap, double *s, double *scond, double *amax, int *info);
  void zpprfs_(char *uplo, int *n, int *nrhs, cpx16 *ap, cpx16 *afp, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
  void zppsv_(char *uplo, int *n, int *nrhs, cpx16 *ap, cpx16 *b, int *ldb, int *info);
  void zppsvx_(char *fact, char *uplo, int *n, int *nrhs, cpx16 *ap, cpx16 *afp, char *equed, double *s, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *rcond, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
  void zpptrf_(char *uplo, int *n, cpx16 *ap, int *info);
  void zpptri_(char *uplo, int *n, cpx16 *ap, int *info);
  void zpptrs_(char *uplo, int *n, int *nrhs, cpx16 *ap, cpx16 *b, int *ldb, int *info);
  void zptcon_(int *n, double *d, cpx16 *e, double *anorm, double *rcond, double *rwork, int *info);
  void zpteqr_(char *compz, int *n, double *d, double *e, cpx16 *z, int *ldz, double *work, int *info);
  void zptrfs_(char *uplo, int *n, int *nrhs, double *d, cpx16 *e, double *df, cpx16 *ef, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
  void zptsv_(int *n, int *nrhs, double *d, cpx16 *e, cpx16 *b, int *ldb, int *info);
  void zptsvx_(char *fact, int *n, int *nrhs, double *d, cpx16 *e, double *df, cpx16 *ef, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *rcond, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
  void zpttrf_(int *n, double *d, cpx16 *e, int *info);
  void zpttrs_(char *uplo, int *n, int *nrhs, double *d, cpx16 *e, cpx16 *b, int *ldb, int *info);
  void zspcon_(char *uplo, int *n, cpx16 *ap, int *ipiv, double *anorm, double *rcond, cpx16 *work, int *info);
  void zsprfs_(char *uplo, int *n, int *nrhs, cpx16 *ap, cpx16 *afp, int *ipiv, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
  void zspsv_(char *uplo, int *n, int *nrhs, cpx16 *ap, int *ipiv, cpx16 *b, int *ldb, int *info);
  void zspsvx_(char *fact, char *uplo, int *n, int *nrhs, cpx16 *ap, cpx16 *afp, int *ipiv, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *rcond, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
  void zsptrf_(char *uplo, int *n, cpx16 *ap, int *ipiv, int *info);
  void zsptri_(char *uplo, int *n, cpx16 *ap, int *ipiv, cpx16 *work, int *info);
  void zsptrs_(char *uplo, int *n, int *nrhs, cpx16 *ap, int *ipiv, cpx16 *b, int *ldb, int *info);
  void zstedc_(char *compz, int *n, double *d, double *e, cpx16 *z, int *ldz, cpx16 *work, int *lwork, double *rwork, int *lrwork, int *iwork, int *liwork, int *info);
  void zstein_(int *n, double *d, double *e, int *m, double *w, int *iblock, int *isplit, cpx16 *z, int *ldz, double *work, int *iwork, int *ifail, int *info);
  void zsteqr_(char *compz, int *n, double *d, double *e, cpx16 *z, int *ldz, double *work, int *info);
  void zsycon_(char *uplo, int *n, cpx16 *a, int *lda, int *ipiv, double *anorm, double *rcond, cpx16 *work, int *info);
  void zsyrfs_(char *uplo, int *n, int *nrhs, cpx16 *a, int *lda, cpx16 *af, int *ldaf, int *ipiv, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
  void zsysv_(char *uplo, int *n, int *nrhs, cpx16 *a, int *lda, int *ipiv, cpx16 *b, int *ldb, cpx16 *work, int *lwork, int *info);
  void zsysvx_(char *fact, char *uplo, int *n, int *nrhs, cpx16 *a, int *lda, cpx16 *af, int *ldaf, int *ipiv, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *rcond, double *ferr, double *berr, cpx16 *work, int *lwork, double *rwork, int *info);
  void zsytf2_(char *uplo, int *n, cpx16 *a, int *lda, int *ipiv, int *info);
  void zsytrf_(char *uplo, int *n, cpx16 *a, int *lda, int *ipiv, cpx16 *work, int *lwork, int *info);
  void zsytri_(char *uplo, int *n, cpx16 *a, int *lda, int *ipiv, cpx16 *work, int *info);
  void zsytrs_(char *uplo, int *n, int *nrhs, cpx16 *a, int *lda, int *ipiv, cpx16 *b, int *ldb, int *info);
  void ztbcon_(char *norm, char *uplo, char *diag, int *n, int *kd, cpx16 *ab, int *ldab, double *rcond, cpx16 *work, double *rwork, int *info);
  void ztbrfs_(char *uplo, char *trans, char *diag, int *n, int *kd, int *nrhs, cpx16 *ab, int *ldab, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
  void ztbtrs_(char *uplo, char *trans, char *diag, int *n, int *kd, int *nrhs, cpx16 *ab, int *ldab, cpx16 *b, int *ldb, int *info);
  void ztgevc_(char *side, char *howmny, int *select, int *n, cpx16 *a, int *lda, cpx16 *b, int *ldb, cpx16 *vl, int *ldvl, cpx16 *vr, int *ldvr, int *mm, int *m, cpx16 *work, double *rwork, int *info);
  void ztgsja_(char *jobu, char *jobv, char *jobq, int *m, int *p, int *n, int *k, int *l, cpx16 *a, int *lda, cpx16 *b, int *ldb, double *tola, double *tolb, double *alpha, double *beta, cpx16 *u, int *ldu, cpx16 *v, int *ldv, cpx16 *q, int *ldq, cpx16 *work, int *ncycle, int *info);
  void ztpcon_(char *norm, char *uplo, char *diag, int *n, cpx16 *ap, double *rcond, cpx16 *work, double *rwork, int *info);
  void ztprfs_(char *uplo, char *trans, char *diag, int *n, int *nrhs, cpx16 *ap, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
  void ztptri_(char *uplo, char *diag, int *n, cpx16 *ap, int *info);
  void ztptrs_(char *uplo, char *trans, char *diag, int *n, int *nrhs, cpx16 *ap, cpx16 *b, int *ldb, int *info);
  void ztrcon_(char *norm, char *uplo, char *diag, int *n, cpx16 *a, int *lda, double *rcond, cpx16 *work, double *rwork, int *info);
  void ztrevc_(char *side, char *howmny, int *select, int *n, cpx16 *t, int *ldt, cpx16 *vl, int *ldvl, cpx16 *vr, int *ldvr, int *mm, int *m, cpx16 *work, double *rwork, int *info);
  void ztrexc_(char *compq, int *n, cpx16 *t, int *ldt, cpx16 *q, int *ldq, int *ifst, int *ilst, int *info);
  void ztrrfs_(char *uplo, char *trans, char *diag, int *n, int *nrhs, cpx16 *a, int *lda, cpx16 *b, int *ldb, cpx16 *x, int *ldx, double *ferr, double *berr, cpx16 *work, double *rwork, int *info);
  void ztrsen_(char *job, char *compq, int *select, int *n, cpx16 *t, int *ldt, cpx16 *q, int *ldq, cpx16 *w, int *m, double *s, double *sep, cpx16 *work, int *lwork, int *info);
  void ztrsna_(char *job, char *howmny, int *select, int *n, cpx16 *t, int *ldt, cpx16 *vl, int *ldvl, cpx16 *vr, int *ldvr, double *s, double *sep, int *mm, int *m, cpx16 *work, int *ldwork, double *rwork, int *info);
  void ztrsyl_(char *trana, char *tranb, int *isgn, int *m, int *n, cpx16 *a, int *lda, cpx16 *b, int *ldb, cpx16 *c, int *ldc, double *scale, int *info);
  void ztrti2_(char *uplo, char *diag, int *n, cpx16 *a, int *lda, int *info);
  void ztrtri_(char *uplo, char *diag, int *n, cpx16 *a, int *lda, int *info);
  void ztrtrs_(char *uplo, char *trans, char *diag, int *n, int *nrhs, cpx16 *a, int *lda, cpx16 *b, int *ldb, int *info);
  void ztzrqf_(int *m, int *n, cpx16 *a, int *lda, cpx16 *tau, int *info);
  void zung2l_(int *m, int *n, int *k, cpx16 *a, int *lda, cpx16 *tau, cpx16 *work, int *info);
  void zung2r_(int *m, int *n, int *k, cpx16 *a, int *lda, cpx16 *tau, cpx16 *work, int *info);
  void zungbr_(char *vect, int *m, int *n, int *k, cpx16 *a, int *lda, cpx16 *tau, cpx16 *work, int *lwork, int *info);
  void zunghr_(int *n, int *ilo, int *ihi, cpx16 *a, int *lda, cpx16 *tau, cpx16 *work, int *lwork, int *info);
  void zungl2_(int *m, int *n, int *k, cpx16 *a, int *lda, cpx16 *tau, cpx16 *work, int *info);
  void zunglq_(int *m, int *n, int *k, cpx16 *a, int *lda, cpx16 *tau, cpx16 *work, int *lwork, int *info);
  void zungql_(int *m, int *n, int *k, cpx16 *a, int *lda, cpx16 *tau, cpx16 *work, int *lwork, int *info);
  void zungqr_(int *m, int *n, int *k, cpx16 *a, int *lda, cpx16 *tau, cpx16 *work, int *lwork, int *info);
  void zungr2_(int *m, int *n, int *k, cpx16 *a, int *lda, cpx16 *tau, cpx16 *work, int *info);
  void zungrq_(int *m, int *n, int *k, cpx16 *a, int *lda, cpx16 *tau, cpx16 *work, int *lwork, int *info);
  void zungtr_(char *uplo, int *n, cpx16 *a, int *lda, cpx16 *tau, cpx16 *work, int *lwork, int *info);
  void zunm2l_(char *side, char *trans, int *m, int *n, int *k, cpx16 *a, int *lda, cpx16 *tau, cpx16 *c, int *ldc, cpx16 *work, int *info);
  void zunm2r_(char *side, char *trans, int *m, int *n, int *k, cpx16 *a, int *lda, cpx16 *tau, cpx16 *c, int *ldc, cpx16 *work, int *info);
  void zunmbr_(char *vect, char *side, char *trans, int *m, int *n, int *k, cpx16 *a, int *lda, cpx16 *tau, cpx16 *c, int *ldc, cpx16 *work, int *lwork, int *info);
  void zunmhr_(char *side, char *trans, int *m, int *n, int *ilo, int *ihi, cpx16 *a, int *lda, cpx16 *tau, cpx16 *c, int *ldc, cpx16 *work, int *lwork, int *info);
  void zunml2_(char *side, char *trans, int *m, int *n, int *k, cpx16 *a, int *lda, cpx16 *tau, cpx16 *c, int *ldc, cpx16 *work, int *info);
  void zunmlq_(char *side, char *trans, int *m, int *n, int *k, cpx16 *a, int *lda, cpx16 *tau, cpx16 *c, int *ldc, cpx16 *work, int *lwork, int *info);
  void zunmql_(char *side, char *trans, int *m, int *n, int *k, cpx16 *a, int *lda, cpx16 *tau, cpx16 *c, int *ldc, cpx16 *work, int *lwork, int *info);
  void zunmqr_(char *side, char *trans, int *m, int *n, int *k, cpx16 *a, int *lda, cpx16 *tau, cpx16 *c, int *ldc, cpx16 *work, int *lwork, int *info);
  void zunmr2_(char *side, char *trans, int *m, int *n, int *k, cpx16 *a, int *lda, cpx16 *tau, cpx16 *c, int *ldc, cpx16 *work, int *info);
  void zunmrq_(char *side, char *trans, int *m, int *n, int *k, cpx16 *a, int *lda, cpx16 *tau, cpx16 *c, int *ldc, cpx16 *work, int *lwork, int *info);
  void zunmtr_(char *side, char *uplo, char *trans, int *m, int *n, cpx16 *a, int *lda, cpx16 *tau, cpx16 *c, int *ldc, cpx16 *work, int *lwork, int *info);
  void zupgtr_(char *uplo, int *n, cpx16 *ap, cpx16 *tau, cpx16 *q, int *ldq, cpx16 *work, int *info);
  void zupmtr_(char *side, char *uplo, char *trans, int *m, int *n, cpx16 *ap, cpx16 *tau, cpx16 *c, int *ldc, cpx16 *work, int *info);
}

#endif
